
          //--------------------------------------------//
          //           .         //
          //            !           //
          //         Copiryght@ 1996-2004.              //
          //         Programmer Bannikov N.A.           //
          //         Universal Database Server 6.0      //
          //         STIKRIZ Technology.                //
          //--------------------------------------------//

unit AdoClasses;

{$I Un.INC}                                              

interface

 uses Windows, SysUtils, classes, Db, OleCtrls, ADOR_TLB, ADODB_TLB, UnConstants,
      UnCustomDataSet, UnFetchTable, UnRecordSet, ActiveX, ComObj, UnADOParams,
      DbTables, UnFileServices
{$IFDEF Un_D6}
     , Variants
{$ENDIF}
      ;

 Type

   TUnAdoConnect = class;

   TAdoNotification = procedure(Connect: TUnAdoConnect) of Object;
   TAdoFechFunc = procedure(RecordSet: _Recordset; FieldIndex: Word; Buffer: PChar{; FechPosition: Cardinal});

   TUnAdoAttribute = (una_CommitRetaining, una_AbortRetaining, una_AsyncPhaseOne, una_SyncPhaseOne);
   TUnAdoAttributes = set of TUnAdoAttribute;

   TUnAdoConnectMode  = (unam_ModeUnknown, unam_ModeRead, unam_ModeWrite,
       unam_ModeReadWrite, unam_ModeShareDenyRead, unam_ModeShareDenyWrite,
       unam_ModeShareExclusive, unam_ModeShareDenyNone);

   TUnAdoLockType = (unlt_Unspecified, unlt_ReadOnly, unlt_Pessimistic,
                      unlt_Optimistic, unlt_BatchOptimistic);

   //     
   TUnAdoConnect = class(TComponent)       
    private
     FConnectString: string;             //  
     FUserName: string;                  //  
     FPassword: string;                  // 
     FAsynchronous: boolean;             //  
     FLoginPromt: boolean;               //     
     FOnOpen: TAdoNotification;          //   
     FOnClose: TAdoNotification;         //   
     FConnection: _Connection;           //  
     FCommandTimeout: Integer;
     FConnectionTimeout: Integer;
     FAttributes: TUnAdoAttributes;      //  
     FCursorInServer: boolean;           //  
     FMode: TUnAdoConnectMode;           // 
     FTransactionLevel: Integer;         //   -   ?
     function GetActive: boolean;
     procedure SetActive(Value: boolean);
     function GetInTransaction: boolean;
    protected
     procedure WaitForConnectComplete;
     procedure WaitForDisconectComplete;
    public
     constructor Create(AOwner: TComponent); override;
     destructor Destroy; override;
     procedure Open;
     procedure Close;
     function StartTransaction: Integer;
     function Commit: Integer;
     function RollBack: Integer;
     property TransactionLevel: Integer read FTransactionLevel;
     property InTransaction: boolean read GetInTransaction;
     property Connection: _Connection read FConnection;
    published
     property ConnectString: string read FConnectString write FConnectString;
     property UserName: string read FUserName write FUserName;
     property Password: string read FPassword write FPassword;
     property Asynchronous: boolean read FAsynchronous write FAsynchronous;
     property LoginPromt: boolean read FLoginPromt write FLoginPromt;
     property OnOpen: TAdoNotification read FOnOpen write FOnOpen;
     property OnClose: TAdoNotification read FOnClose write FOnClose;
     property CommandTimeout: Integer read FCommandTimeout write FCommandTimeout;
     property ConnectionTimeout: Integer read FConnectionTimeout write FConnectionTimeout;
     property Attributes: TUnAdoAttributes read FAttributes write FAttributes;
     property CursorInServer: boolean read FCursorInServer write FCursorInServer;
     property Mode: TUnAdoConnectMode read FMode write FMode;
     property Active: boolean read GetActive write SetActive;
   end;

   // 
   TUnCustomAdoRecordSet = class(TComponent)
    private
     FActive: boolean;
     FCashSize: Integer;                   //  
     FRecordSet: _Recordset;               //  
     FSQL: TStringList;                    // SQL  
     FRealSQL: string;                     //    
     FConnection: TUnAdoConnect;           // 
     FLockType: TUnAdoLockType;            // 
     FOnGetParam: TUnGetParametrValue;     //    
     function GetSQL: TStrings;
     procedure SetSQL(Value: TStrings);
     function GetActive: boolean;
     procedure SetActive(Value: boolean);
     function GetEof: boolean;
     function GetBof: boolean;
     function GetFieldCount: Word;
     function GetRecordSet: _Recordset;
    protected
     function CreateErrorString: string; virtual;
     property OnGetParam: TUnGetParametrValue read FOnGetParam write FOnGetParam;
    public
     constructor Create(AOwner: TComponent); override;
     destructor Destroy; override;
     procedure Open; virtual;
     procedure Close; virtual;
     procedure Next;
     property Eof: boolean read GetEof;
     property Bof: boolean read GetBof;
     property Connection: TUnAdoConnect read FConnection write FConnection;
     property LockType: TUnAdoLockType read FLockType write FLockType;
     property SQL: TStrings read GetSQL write SetSQL;
     property Active: boolean read GetActive write SetActive;
     property FieldCount: Word read GetFieldCount;
     property RecordSet: _Recordset read GetRecordSet;
     property CashSize: Integer read FCashSize write FCashSize;
   end;

   TUnADORecordSet = class(TUnCustomAdoRecordSet)
    private
     FParams: TParams;
    protected
     procedure DoGetParamValue(const ParamName: string; IsOld: boolean; var ParamType: TFieldType; var ParamValue: Variant);
    public
     constructor Create(AOwner: TComponent); override;
     destructor Destroy; override;
    published
     property Connection;
     property LockType;
     property SQL;
     property CashSize;
     property Params: TParams read FParams;
     property Active;
   end;

   // 
   TUnCustomAdoFetcher = class(TUnCustomFetcher)
    private
     FQuery: TUnCustomAdoRecordSet;          // 
     FieldFechIndex: POffsetsArray;    //   
     FCashSize: Integer;               //     
     procedure SetCashSize(Value: Integer);
     function GetLockType: TUnAdoLockType;
     procedure SetLockType(Value: TUnAdoLockType);
     procedure DoGetParamValue(const ParamName: string; IsOld: boolean; var ParamType: TFieldType; var ParamValue: Variant);
    protected
     function GetReadConnect: TUnAdoConnect; virtual;
     procedure SetReadConnect(Value: TUnAdoConnect); virtual;
     function GetWriteConnect: TUnAdoConnect; virtual; abstract;
     procedure SetWriteConnect(Value: TUnAdoConnect); virtual; abstract;
     function GetActive: boolean; override;
     procedure SetActive(const Value: boolean); override;
     function GetBof: boolean; override;
     function GetEof: boolean; override;
     function GetSQL: TStrings; override;
     procedure SetSQL(const Value: TStrings); override;
     procedure GetNextData(AData: PChar); override;
     procedure InitializeFields(ADataSet: TDataSet); override;
     function GetFieldCount: Word; override;
    public
     constructor Create(AOwner: TComponent); override;
     destructor Destroy; override;
     procedure Open; override;
     procedure Close; override;
    published
     property ReadConnect: TUnAdoConnect read GetReadConnect write SetReadConnect;
     property WriteConnect: TUnAdoConnect read GetWriteConnect write SetWriteConnect;
     property LockType: TUnAdoLockType read GetLockType write SetLockType;
     property CashSize: Integer read FCashSize write SetCashSize;
   end;

 var
 
 str_Not_Assign_Connect:             string = 'Not assign connect !';
 str_NoMatchingADOType:              string = 'No matching ADO data type for %s !';
 str_InvalidDataConversion:          string = 'Invalid Data Conversion !';
 str_Not_Open_Connect:               string = 'Connection is not established !';
 str_Not_Assigned_Param_Event:       string = 'Event for get param value is not assigned !';
 str_Not_Assigned_DataSet:           string = 'No assigned dataset !';
 str_Not_Assigned_Master_DataSource: string = 'No find param or No assigned master datasource !';
 str_Params_Not_Assigh:              string = 'Not assign params !';
 str_Not_Find_Param:                 string = 'Param %s not found';
 str_Cancel_Connect:                 string = 'Connection is interrupted !';
 str_ERROR_FETCH:                    string = 'Error fech !';

  AFechFuncList: array[0..22] of TAdoFechFunc;
  II: Integer;

 const
  REGDB_E_CLASSNOTREG = HRESULT($80040154);
  str_ADOCreateError = 'Error creating object.  Please verify that the Microsoft Data Access Components 2.1 (or later) have been properly installed';

function CreateADOObject(const ClassID: TGUID): IUnknown;
function ADOTypeToFieldType(const ADOType: DataTypeEnum): TFieldType;
procedure ParsingSQL(const SQL: string; var RealSQL: string; Params: TUnADOParams; DoGetParam: TUnGetParametrValue; var IsExec: boolean);
procedure _DoGetParamValue(DataSet: TDataSet; const ParamName: string; IsOld: boolean; var ParamType: TFieldType; var ParamValue: Variant);
function _FindField(DataSet: TDataSet; const AFieldName: string; var Field: TField): boolean;
function _FindParam(Params: TParams; const AFieldName: string; var Param: TParam): boolean;


implementation

uses UnPasswordForm, Controls;

 Type

    HackDataSet = class(TUnDataSet);

function _FindField(DataSet: TDataSet; const AFieldName: string; var Field: TField): boolean;
var I: Integer;
begin
 Result:=false;
 for I:=0 to DataSet.FieldCount-1 do
  begin
   if CompareText(DataSet.Fields[I].FieldName, AFieldName) = 0 then
    begin
     Field:=DataSet.Fields[I];
     Result:=true;
     Break;
    end;
  end;
end;

function _FindParam(Params: TParams; const AFieldName: string; var Param: TParam): boolean;
var I: Integer;
begin
 Result:=false;
 for I:=0 to Params.Count-1 do
  begin
   if CompareText(Params[I].Name, AFieldName) = 0 then
    begin
     Param:=Params[I];
     Result:=true;
     Break;
    end;
  end;
end;

procedure ParsingSQL(const SQL: string; var RealSQL: string; Params: TUnADOParams; DoGetParam: TUnGetParametrValue; var IsExec: boolean);
var TempString, StringValue: string;
    DataType: TFieldType;
    ParamValue: Variant;
    IsOld: boolean;
    OldDecimalSeparator: Char;
    OldDateSeparator: Char;
    OldTimeSeparator: Char;
    CountCS: Integer;
    CountDS: Integer;
    s: PChar;
    ts: PChar;
begin  //  
 CountCS:=0;
 CountDS:=0;
 IsExec:=false;
 OldDecimalSeparator:=DecimalSeparator;
 OldDateSeparator:=DateSeparator;
 OldTimeSeparator:=TimeSeparator;
 try
  DecimalSeparator:='.';
  DateSeparator:='.';
  TimeSeparator:=':';
  RealSQL:='';
  if Params <> nil then
  Params.Clear;
  s:=PChar(SQL);
  while s^ <> #0 do
   begin
    case s^ of
      ':': begin //  
            if s^ <> #0 then
             if (s+1)^ in BreakSimbols then
              begin
               RealSQL:=RealSQL+s^;
               Inc(s);
               Continue;
              end;
            TempString:='';
            Inc(s);
            IsOld:=false;
            while s^ <> #0 do
             begin
              if ((s^ < '0') or ((s^ > '9') and (s^ < 'A')) or (s^ > 'z') or (s^ = #0)) and (s^ <> '_') then
               begin //  
                if not Assigned(DoGetParam) then
                 raise Exception.Create(str_Not_Assigned_Param_Event);
                DoGetParam(TempString, IsOld, DataType, ParamValue);
                if ParamValue = Null then
                 begin
                  RealSQL:=RealSQL+' NULL';
                 end
                else
                 case DataType of
                  ftFmtMemo, ftMemo, ftString: begin
                    TempString:=ParamValue;
                    StringValue:='';
                    ts:=PChar(TempString);
                    while ts^ <> #0 do
                     begin
                      if ts^ = '''' then
                       StringValue:=StringValue+''''''
                      else
                       StringValue:=StringValue+ts^;
                      inc(ts);
                     end;
                    RealSQL:=RealSQL+''''+StringValue+''' ';
                   end;
                  ftBoolean: begin
                    if ParamValue then
                     RealSQL:=RealSQL+'1 '
                    else
                     RealSQL:=RealSQL+'0 ';
                   end;
                  ftSmallint, ftInteger, ftWord, ftAutoInc: RealSQL:=RealSQL+IntToStr(ParamValue)+' ';
                  ftFloat, ftCurrency, ftBCD:RealSQL:=RealSQL+FloatToStr(ParamValue)+' ';
                  ftDate: RealSQL:=RealSQL+''''+FormatDateTime('mm/dd/yyyy', ParamValue)+''' ';
                  ftTime: RealSQL:=RealSQL+''''+TimeToStr(ParamValue)+''' ';
                  ftDateTime: RealSQL:=RealSQL+''''+FormatDateTime('mm/dd/yyyy hh:mm', ParamValue)+''' ';
                  ftBytes, ftVarBytes, ftBlob, ftGraphic, ftParadoxOle, ftDBaseOle, ftTypedBinary: begin
                    RealSQL:=RealSQL+' ? ';
                    if Params <> nil then
                     Params.Add(TempString, DataType, ptInput, VarArrayHighBound(ParamValue, 1), ParamValue)
                    else  raise Exception.Create(str_Params_Not_Assigh);
                   end;
                  else raise Exception.Create(str_InvalidDataConversion);
                 end;
                Dec(s);
                Break;
               end
              else
               begin
                TempString:=TempString+s^;
                if CompareText('Old_', TempString) = 0 then
                 begin
                  TempString:='';
                  IsOld:=true;
                 end;
               end;
              Inc(s);
             end;
           end;
      ';': begin
        if s^ <> #0 then
         if (s+1)^ = '1' then
          if (CountCS mod 2 = 0) and  (CountDS mod 2 = 0) then
           begin
            IsExec:=true;
            RealSQL:=RealSQL+s^;
           end;
       end;
      '''': begin
           Inc(CountCS);
           RealSQL:=RealSQL+s^;
       end;
      '"': begin
           Inc(CountDS);
           RealSQL:=RealSQL+s^;
       end;
      #13: RealSQL:=RealSQL+' '; //   
      #10: ;
      '^': RealSQL:=RealSQL+#13#10+'^'+#13#10;
      else RealSQL:=RealSQL+s^; //   
    end;
    Inc(s);
   end;
 finally
  DecimalSeparator:=OldDecimalSeparator;
  DateSeparator:=OldDateSeparator;
  TimeSeparator:=OldTimeSeparator;
 end;
end;

procedure _DoGetParamValue(DataSet: TDataSet; const ParamName: string; IsOld: boolean; var ParamType: TFieldType; var ParamValue: Variant);
var Fld: TField;
    Str: TStream;
    S: string;
    D: PChar;
    Param: TParam;
begin  //    
 if _FindField(DataSet, Trim(ParamName), Fld) then
  begin
   ParamType:=Fld.DataType;
   if Fld.IsBlob then
    begin
     Str:=GetTempStream;
     try
      (Fld as TBlobField).SaveToStream(Str);
      Str.Position:=0;
      case Fld.DataType of
       ftFmtMemo, ftMemo: begin
         SetLength(S, Str.Size);
         Str.ReadBuffer(S[1], Str.Size);
         ParamValue:=S;
        end;
       else begin
         ParamValue:=VarArrayCreate([0, Str.Size], varByte);
         D:=VarArrayLock(ParamValue);
         try
          Str.ReadBuffer(D^, Str.Size);
         finally
          VarArrayUnlock(ParamValue);
        end;
       end;
      end;
     finally
      Str.Free;
     end;
    end
   else
    begin
     if Fld.DataType = ftString then
      begin
       if IsOld then
        begin
         ParamValue:=Fld.OldValue;
         if ParamValue = Null then
          ParamValue:=Fld.Value;
        end
       else
        ParamValue:=Fld.Value;
      end
     else
      begin
       if IsOld then
        begin
         ParamValue:=Fld.OldValue;
         if ParamValue = Null then
          ParamValue:=Fld.Value;
        end
       else
        ParamValue:=Fld.Value;
      end;
    end;
  end
 else if DataSet is TUnFetchDataSet then
  begin
   if _FindParam(TUnFetchDataSet(DataSet).Params, Trim(ParamName), Param) then
    begin
     ParamType:=Param.DataType;
     if ParamType in [
                      ftBytes, ftVarBytes, ftBlob, ftMemo, ftGraphic,
                      ftFmtMemo, ftParadoxOle, ftDBaseOle, ftTypedBinary
{$IFDEF UN_D5}
                      , ftOraBlob
{$ENDIF}
                     ] then
      begin
       S:=Param.AsBlob;
       Str:=GetTempStream;
       try
        Str.Write(S[1], Length(S));
        Str.Position:=0;
        case Fld.DataType of
         ftFmtMemo, ftMemo: begin
           SetLength(S, Str.Size);
           Str.ReadBuffer(S[1], Str.Size);
           ParamValue:=S;
          end;
         else begin
           ParamValue:=VarArrayCreate([0, Str.Size], varByte);
           D:=VarArrayLock(ParamValue);
           try
            Str.ReadBuffer(D^, Str.Size);
           finally
            VarArrayUnlock(ParamValue);
          end;
         end;
        end;
       finally
        Str.Free;
       end;
      end
     else
      begin
       if Fld.DataType = ftString then
         ParamValue:=Param.AsString
       else
         ParamValue:=Param.Value;
      end;
    end
   else
    raise Exception.CreateFmt(str_Not_Find_Param, [ParamName]);
  end
 else
  raise Exception.CreateFmt(str_Not_Find_Param, [ParamName]);
end;

function ADOTypeToFieldType(const ADOType: DataTypeEnum): TFieldType;
begin  //   -  
  case ADOType of
    adEmpty: Result := ftUnknown;
    adTinyInt, adSmallInt: Result := ftSmallint;
    adError, adInteger, adUnsignedInt: Result := ftInteger;
    adUnsignedTinyInt, adUnsignedSmallInt: Result := ftWord;
    adSingle, adDouble: Result := ftFloat;
    adCurrency: Result := ftCurrency;
    adBoolean: Result := ftBoolean;
    adDBDate: Result := ftDate;
    adDBTime: Result := ftTime;
    adDate, adDBTimeStamp, adFileTime, adDBFileTime: Result := ftDateTime;
    adChar: Result := ftString;
    adVarChar: Result := ftString;
    adBSTR, adWChar, adVarWChar: Result := ftString;
    adLongVarChar, adLongVarWChar: Result := ftMemo;
    adLongVarBinary: Result := ftBlob;
    adBinary: Result := ftBytes;
    adVarBinary: Result := ftVarBytes;
{$IFDEF UN_D4}
    adBigInt, adUnsignedBigInt: Result:=ftLargeInt;
{$ENDIF}
{$IFDEF UN_D5}
    adPropVariant, adVariant: Result := ftVariant;
    adIDispatch: Result := ftIDispatch;
    adIUnknown: Result := ftInterface;
    adGUID: Result := ftGuid;
{$ELSE}
    adPropVariant, adVariant: Result := ftString;
{$ENDIF}
    adDecimal, adNumeric, adVarNumeric: Result := ftFloat
  else
    Result := ftUnknown;
  end;
end;

function CreateADOObject(const ClassID: TGUID): IUnknown;
var
  Status: LongInt;
  FPUControlWord: Word;
begin  //   
  asm
    FNSTCW  FPUControlWord
  end;
  Status := CoCreateInstance(ClassID, nil, CLSCTX_INPROC_SERVER or
    CLSCTX_LOCAL_SERVER, IUnknown, Result);
  asm
    FNCLEX
    FLDCW FPUControlWord
  end;
  if (Status = REGDB_E_CLASSNOTREG) then
    raise Exception.Create(str_ADOCreateError) else
    OleCheck(Status);
end;

{-------------------------------TUnAdoConnect----------------------------------}

constructor TUnAdoConnect.Create(AOwner: TComponent);
begin
 inherited;
 FConnection := CreateADOObject(CLASS_Connection) as _Connection;
 FAsynchronous:=false;
 FLoginPromt:=true;
 FCommandTimeout:=30;
 FConnectionTimeout:=15;
 FAttributes:=[];
 FCursorInServer:=true;
 FMode:=unam_ModeReadWrite;
 FTransactionLevel:=0;
end;

destructor TUnAdoConnect.Destroy;
begin
 Close;
 FConnection:=nil;
 inherited;
end;

procedure TUnAdoConnect.Open;
var Attributes: TOleEnum;
    PasswordForm: TfPasswordForm;
begin  //  
 try
 if Assigned(FConnection) then
  begin
   if not Active then
    begin
     FConnection.CommandTimeout:=CommandTimeout;
     FConnection.ConnectionTimeout:=ConnectionTimeout;
     if Asynchronous then
      FConnection.IsolationLevel:=adAsyncConnect
     else
      FConnection.IsolationLevel:=4096;
     Attributes := 0;
     if una_CommitRetaining in FAttributes then
      Attributes := Attributes +adXactCommitRetaining;
     if una_AbortRetaining in FAttributes then
      Attributes := Attributes +adXactAbortRetaining;
     if una_AsyncPhaseOne in FAttributes then
      Attributes := Attributes +adXactAsyncPhaseOne;
     if una_SyncPhaseOne in FAttributes then
      Attributes := Attributes +adXactSyncPhaseOne;
     FConnection.Attributes := Attributes;
     if FCursorInServer then
      FConnection.CursorLocation:=adUseServer
     else
      FConnection.CursorLocation:=adUseClient;
     case FMode of
      unam_ModeUnknown: FConnection.Mode:=adModeUnknown;
      unam_ModeRead: FConnection.Mode:=adModeRead;
      unam_ModeWrite: FConnection.Mode:=adModeWrite;
      unam_ModeReadWrite: FConnection.Mode:=adModeReadWrite;
      unam_ModeShareDenyRead: FConnection.Mode:=adModeShareDenyRead;
      unam_ModeShareDenyWrite: FConnection.Mode:= adModeShareDenyWrite;
      unam_ModeShareExclusive: FConnection.Mode:=adModeShareExclusive;
      unam_ModeShareDenyNone: FConnection.Mode:=adModeShareDenyNone;
     end;
    if FLoginPromt then
     begin
      PasswordForm:=TfPasswordForm.Create(nil);
      try
       PasswordForm.UserName:=FUserName;
       if PasswordForm.ShowModal = mrOk then
        begin
         FUserName:=PasswordForm.UserName;
         FPassword:=PasswordForm.Password;
        end
       else
        raise TUnDbException.Create(str_Cancel_Connect);
      finally
       PasswordForm.Free;
      end;
     end;
    if FAsynchronous then
     FConnection.Open(FConnectString, FUserName, FPassword, adAsyncConnect)
    else
     FConnection.Open(FConnectString, FUserName, FPassword, adConnectUnspecified);
    WaitForConnectComplete;
   end;
  end
 else
  raise TUnDbException.Create(str_Not_Open_Connect);
 except
   if not (csDesigning in ComponentState) then
    raise;
 end;
end;

procedure TUnAdoConnect.WaitForConnectComplete;
begin //      
 if Assigned(FConnection) then
  while (FConnection.State = adStateConnecting) do
   SleepEx(10, false);
end;

procedure TUnAdoConnect.WaitForDisconectComplete;
begin //      
 if Assigned(FConnection) then
  while not (FConnection.State = adStateClosed) do
   SleepEx(10, false);
end;

procedure TUnAdoConnect.Close;
begin //  
 if Assigned(FConnection) then
  if Active then
   begin
    while InTransaction do RollBack;
    FConnection.Close;
    WaitForDisconectComplete;
   end;
end;

function TUnAdoConnect.GetActive: boolean;
begin
 if Assigned(FConnection) then
  begin
   Result:=FConnection.State and adStateOpen <> 0;
  end
 else
  Result:=false;
end;

procedure TUnAdoConnect.SetActive(Value: boolean);
begin
 if Value then
  Open
 else
  Close;
end;

function TUnAdoConnect.GetInTransaction: boolean;
begin
 if Active then
  Result:=FTransactionLevel > 0
 else
  Result:=false;
end;

function TUnAdoConnect.StartTransaction: Integer;
begin
 if Active then
  begin
   FTransactionLevel:=FConnection.BeginTrans;
   Result:=FTransactionLevel;
  end
 else
  raise TUnDbException.Create(str_Not_Open_Connect);
end;

function TUnAdoConnect.Commit: Integer;
begin
 if Active then
  begin
   FConnection.CommitTrans;
   FTransactionLevel:=FTransactionLevel-1;
   Result:=FTransactionLevel;
  end
 else
  raise TUnDbException.Create(str_Not_Open_Connect);
end;

function TUnAdoConnect.RollBack: Integer;
begin
 if Active then
  begin
   FConnection.RollbackTrans;
   FTransactionLevel:=FTransactionLevel-1;
   Result:=FTransactionLevel;
  end
 else
  raise TUnDbException.Create(str_Not_Open_Connect);
end;

{--------------------------------TUnAdoRecordSet-------------------------------}

constructor TUnCustomAdoRecordSet.Create;
begin
 inherited;
 FActive:=false;
 FCashSize:=1;
 FSQL:=TStringList.Create;
 FLockType:=unlt_ReadOnly;
 FConnection:=nil;
end;

destructor TUnCustomAdoRecordSet.Destroy;
begin
 FSQL.Free;
 FRecordSet:=nil;
 inherited;
end;

function TUnCustomAdoRecordSet.GetRecordSet: _Recordset;
begin
 Result:=FRecordSet;
end;

function TUnCustomAdoRecordSet.GetSQL: TStrings;
begin
 Result:=FSQL as TStrings;
end;

procedure TUnCustomAdoRecordSet.SetSQL(Value: TStrings);
begin
 FSQL.Assign(Value);
end;

function TUnCustomAdoRecordSet.GetActive: boolean;
begin
 Result:=FActive;
end;

procedure TUnCustomAdoRecordSet.SetActive(Value: boolean);
begin
 if Value then
  Open
 else
  Close;
end;

function TUnCustomAdoRecordSet.GetEof: boolean;
begin
 if Active then
  Result:=FRecordSet.EOF
 else
  Result:=true;
end;

function TUnCustomAdoRecordSet.GetBof: boolean;
begin
 if Active then
  Result:=FRecordSet.BOF
 else
  Result:=true;
end;

procedure TUnCustomAdoRecordSet.Open;
var Locks: Shortint;
    IsExec: boolean;
begin
 try
  if FConnection = nil then  //  
   raise TUnDbException.Create(str_Not_Assign_Connect);
  if not FConnection.Active then
   FConnection.Open;  //  ,    
  if not Active then
   begin
    FRecordSet:=CreateADOObject(CLASS_Recordset) as _Recordset;
    try
     if FCashSize > 0 then
      FRecordSet.CacheSize:=FCashSize
     else  //        
      FRecordSet.CacheSize:=1;
     //   
     FRecordSet.MaxRecords:=0;
     case FLockType of
      unlt_ReadOnly: Locks:=adLockReadOnly;
      unlt_Pessimistic: Locks:=adLockPessimistic;
      unlt_Optimistic: Locks:=adLockOptimistic;
      unlt_BatchOptimistic: Locks:=adLockBatchOptimistic;
      else Locks:=adLockUnspecified;
     end;                          
     if not FConnection.Active then
      FConnection.Active:=true;
     ParsingSQL(FSQL.Text, FRealSQL, nil, FOnGetParam, IsExec); //            //   
     FRecordSet.Open(FRealSQL, FConnection.FConnection, adOpenForwardOnly, Locks, adCmdText+adAsyncFetch);
     FActive:=true;
    except on Exception do
     begin
      FRecordSet:=nil;
      raise;
     end;
    end;
   end;
 except on E: Exception do
  begin
   E.Message:=E.Message+#13#10+CreateErrorString;
    raise;
  end;
 end;
end;

procedure TUnCustomAdoRecordSet.Close;
begin
 if Active then
  begin
   try
    if FRecordSet <> nil then
     if FRecordSet.State = adStateOpen then
      FRecordSet.Close;
    FRecordSet:=nil;
    FActive:=false;
   except on E: Exception do
    begin
     E.Message:=E.Message+#13#10+CreateErrorString;
     raise;
    end;
   end;
  end;
end;

procedure TUnCustomAdoRecordSet.Next;
begin
 if Active then
  FRecordSet.MoveNext;
end;

function TUnCustomAdoRecordSet.GetFieldCount: Word;
begin
 if Active then
  Result:=FRecordSet.Fields.Count
 else
  Result:=0;
end;

function TUnCustomAdoRecordSet.CreateErrorString: string;
var I: Integer;
    Err: Error;
    Mess: string;
begin  //  , ..    
 Mess:='';
 for I:=0 to FConnection.FConnection.Errors.Count-1 do
  begin
   Err:=FConnection.FConnection.Errors[I];
   Mess:=Mess+Format('ADO Error: %d of %d: %s',
      [I, FConnection.FConnection.Errors.Count, Err.Description])+#13#10;
  end;
end;

{------------------------------TUnADORecordSet---------------------------------}

constructor TUnADORecordSet.Create(AOwner: TComponent);
begin
 inherited;
 FParams:=TParams.Create;
 self.OnGetParam:=DoGetParamValue;
end;

destructor TUnADORecordSet.Destroy;
begin
 FParams.Free;
 inherited;
end;

procedure TUnADORecordSet.DoGetParamValue(const ParamName: string; IsOld: boolean; var ParamType: TFieldType; var ParamValue: Variant);
var I: Integer;
    Par: TParam;
    TempString: string;
    Len: Integer;
    Buffer: PChar;
begin
 for I:=0 to FParams.Count-1 do
  begin
   Par:=FParams[I];
   if CompareText(Par.Name, ParamName) = 0 then
    begin
     ParamType:=Par.DataType;
     case Par.DataType of
      ftFmtMemo, ftMemo: ParamValue:=Par.AsMemo;
      ftBytes, ftVarBytes, ftBlob, ftGraphic, ftParadoxOle, ftDBaseOle, ftTypedBinary: begin
       TempString:=Par.AsBlob;
        Len:=Length(TempString);
        ParamValue:=VarArrayCreate([0, Len], varByte);
        Buffer:=VarArrayLock(ParamValue);
        try
         Move(TempString[1], Buffer^, Len);
        finally
         VarArrayUnlock(ParamValue);
        end;
       end;
      else ParamValue:=Par.Value;
     end;
     Break;
    end;
  end;
end;

{---------------------------------TUnAdoFecher---------------------------------}

constructor TUnCustomAdoFetcher.Create(AOwner: TComponent);
begin
 inherited;
 FQuery:=TUnCustomAdoRecordSet.Create(Self);
 FQuery.OnGetParam:=DoGetParamValue;
 FieldFechIndex:=nil;
end;

destructor TUnCustomAdoFetcher.Destroy;
begin
 //FQuery.Free;
 inherited;
end;

function TUnCustomAdoFetcher.GetReadConnect: TUnAdoConnect;
begin
 Result:=FQuery.Connection;
end;

procedure TUnCustomAdoFetcher.SetReadConnect(Value: TUnAdoConnect);
begin
 FQuery.Connection:=Value;
end;

function TUnCustomAdoFetcher.GetLockType: TUnAdoLockType;
begin
 Result:=FQuery.LockType;
end;

procedure TUnCustomAdoFetcher.SetLockType(Value: TUnAdoLockType);
begin
 FQuery.LockType:=Value;
end;

function TUnCustomAdoFetcher.GetActive: boolean;
begin
 Result:=FQuery.Active;
end;

procedure TUnCustomAdoFetcher.SetActive(const Value: boolean);
begin
 if Value then
  Open
 else
  Close;
end;

procedure TUnCustomAdoFetcher.DoGetParamValue(const ParamName: string; IsOld: boolean; var ParamType: TFieldType; var ParamValue: Variant);
var I: Integer;
    IsOk: boolean;
    Par: TParam;
    TempString: string;
    Buffer: PChar;
    Len: Integer;
begin   //  
 if DataSet = nil then
  raise Exception.Create(str_Not_Assigned_DataSet);
 IsOk:=false;
 if not IsOld then
  begin
   for I:=0 to FetchDataSet.Params.Count - 1 do
    begin
     Par:=FetchDataSet.Params[I];
     if CompareText(Par.Name, ParamName) = 0 then
      begin
       ParamType:=Par.DataType;
       case Par.DataType of
        ftFmtMemo, ftMemo: ParamValue:=Par.AsMemo;
        ftBytes, ftVarBytes, ftBlob, ftGraphic, ftParadoxOle, ftDBaseOle, ftTypedBinary: begin
          TempString:=Par.AsBlob;
          Len:=Length(TempString);
          ParamValue:=VarArrayCreate([0, Len], varByte);
          Buffer:=VarArrayLock(ParamValue);
          try
           Move(TempString[1], Buffer^, Len);
          finally
           VarArrayUnlock(ParamValue);
          end;
         end;
        else ParamValue:=Par.Value;
       end;
       IsOk:= true;
       Break;
      end;
    end;
  end;
 if not IsOk then
  begin
   if FetchDataSet.MasterDataSource = nil then
   raise Exception.Create(str_Not_Assigned_Master_DataSource);
   _DoGetParamValue(FetchDataSet.MasterDataSource.DataSet, ParamName, IsOld, ParamType, ParamValue);
  end;
end;

function TUnCustomAdoFetcher.GetBof: boolean;
begin
 Result:=FQuery.Bof;
end;

function TUnCustomAdoFetcher.GetEof: boolean;
begin
 Result:=FQuery.Eof;
end;

function TUnCustomAdoFetcher.GetSQL: TStrings;
begin
 Result:=FQuery.SQL;
end;

procedure TUnCustomAdoFetcher.SetSQL(const Value: TStrings);
begin
 FQuery.SQL.Assign(Value);
end;

function TUnCustomAdoFetcher.GetFieldCount: Word;
begin
 Result:=FQuery.FieldCount;
end;

procedure TUnCustomAdoFetcher.Open;
begin
 if not Active then
  begin
   FIsFieldsChecked:=false;
   FQuery.FCashSize:=FCashSize;
   FQuery.Open;
  end;
end;

procedure TUnCustomAdoFetcher.SetCashSize(Value: Integer);
begin
 if Value > 0 then
  FCashSize:=Value
 else
  FCashSize:=1;
end;

procedure TUnCustomAdoFetcher.Close;
begin
 if Active then
  begin
   FQuery.Close;
   if FieldFechIndex <> nil then
    FreeMem(FieldFechIndex);
   FieldFechIndex:=nil;
  end;
end;

procedure TUnCustomAdoFetcher.InitializeFields(ADataSet: TDataSet);
var I: Integer;
    FieldType: TFieldType;
    OldOpen: boolean;
    Def: TFieldDef;
begin   //    
 if InitializeFromFieldDefData and (FieldDefData.Size > 0) then
  begin
   FieldDefData.Position:=0;
   LoadFieldDefsFromStream(DataSet.FieldDefs, FieldDefData);
   FIsFieldsChecked:=false;
   HackDataSet(DataSet).FLoadFieldDefsFromStream:=true;
  end
 else
  begin
 OldOpen:=FQuery.Active;
 try
  if not FQuery.Active then
   FQuery.Open;
  for I:=0 to FQuery.FieldCount-1 do
   begin //    
    FieldType:=ADOTypeToFieldType(FQuery.FRecordSet.Fields[I].Type_);
    case FieldType of
     ftString: begin
       TFieldDef.Create(ADataSet.FieldDefs, FQuery.FRecordSet.Fields[I].Name,
                  FieldType, FQuery.FRecordSet.Fields[I].DefinedSize, false, I+1);
      end;
     ftSmallint: begin
       TFieldDef.Create(ADataSet.FieldDefs, FQuery.FRecordSet.Fields[I].Name,
                  FieldType, 0, false, I+1);
      end;
     ftInteger: begin
       TFieldDef.Create(ADataSet.FieldDefs, FQuery.FRecordSet.Fields[I].Name,
                  FieldType, 0, false, I+1);
      end;
     ftWord: begin
       TFieldDef.Create(ADataSet.FieldDefs, FQuery.FRecordSet.Fields[I].Name,
                  FieldType, 0, false, I+1);
      end;
     ftBoolean: begin
       TFieldDef.Create(ADataSet.FieldDefs, FQuery.FRecordSet.Fields[I].Name,
                  FieldType, 0, false, I+1);
      end;
     ftFloat: begin
       Def:=TFieldDef.Create(ADataSet.FieldDefs, FQuery.FRecordSet.Fields[I].Name,
                  FieldType, 0, false, I+1);
       Def.Precision:=FQuery.FRecordSet.Fields[I].Precision;
      end;
     ftCurrency: begin
       Def:=TFieldDef.Create(ADataSet.FieldDefs, FQuery.FRecordSet.Fields[I].Name,
                  FieldType, 0, false, I+1);
       Def.Precision:=FQuery.FRecordSet.Fields[I].Precision;
      end;
     ftDate: begin
       TFieldDef.Create(ADataSet.FieldDefs, FQuery.FRecordSet.Fields[I].Name,
                  FieldType, 0, false, I+1);
      end;
     ftTime: begin
       TFieldDef.Create(ADataSet.FieldDefs, FQuery.FRecordSet.Fields[I].Name,
                  FieldType, 0, false, I+1);
      end;
     ftDateTime: begin
       TFieldDef.Create(ADataSet.FieldDefs, FQuery.FRecordSet.Fields[I].Name,
                  FieldType, 0, false, I+1);
      end;
     ftBytes: begin
       TFieldDef.Create(ADataSet.FieldDefs, FQuery.FRecordSet.Fields[I].Name,
                  FieldType, FQuery.FRecordSet.Fields[I].DefinedSize, false, I+1);
      end;
     ftVarBytes: begin
       TFieldDef.Create(ADataSet.FieldDefs, FQuery.FRecordSet.Fields[I].Name,
                  FieldType, FQuery.FRecordSet.Fields[I].DefinedSize, false, I+1);
      end;
     ftBlob: begin
       TFieldDef.Create(ADataSet.FieldDefs, FQuery.FRecordSet.Fields[I].Name,
                  FieldType, 0, true, I+1);
      end;
     ftMemo: begin
       TFieldDef.Create(ADataSet.FieldDefs, FQuery.FRecordSet.Fields[I].Name,
                  FieldType, 0, true, I+1);
      end;
     else raise TUnDbException.Create(str_InvalidDataConversion);
    end;
    FIsFieldsChecked:=false;
   end;
  finally
   if not OldOpen then
    FQuery.Active:=false;
  end;
 end;
end;

procedure TUnCustomAdoFetcher.GetNextData(AData: PChar);
var I, J: Integer;
    Fld: TField;
    IdFld: Integer; 
    IsData: Boolean;
begin
 if not FIsFieldsChecked then
  begin //    
   if FieldFechIndex <> nil then //      
    FreeMem(FieldFechIndex);
   GetMem(FieldFechIndex, DataSet.FieldCount*Sizeof(Integer));
   FillChar(FieldFechIndex^, DataSet.FieldCount*Sizeof(Integer), 0); //  
   for I:=0 to DataSet.FieldCount-1 do
    begin
     FieldFechIndex[I+1]:= -1;
     for J:=0 to FQuery.FieldCount-1 do
      begin
       if CompareText(DataSet.Fields[I].FieldName, FQuery.FRecordSet.Fields[J].Name) = 0 then
        begin
         FieldFechIndex[I+1]:=J;
         if DataSet.Fields[I].DataType <> ADOTypeToFieldType(FQuery.FRecordSet.Fields[J].Type_) then
          if not (((DataSet.Fields[I].DataType = ftMemo) and (FQuery.FRecordSet.Fields[J].Type_ = adLongVarBinary)) or
           (( DataSet.Fields[I].DataType = ftInteger ) and ( FQuery.FRecordSet.Fields[J].Type_ = adBoolean )) or
           ((DataSet.Fields[I].DataType in [ftDate, ftTime, ftDateTime]) and (FQuery.FRecordSet.Fields[J].Type_ = adDBTimeStamp)) or
           ((DataSet.Fields[I].DataType = ftCurrency) and (FQuery.FRecordSet.Fields[J].Type_ = adDouble)))then

          raise TUnDbException.Create(str_InvalidDataConversion);
         Break;
        end;
      end;
    end;
   FIsFieldsChecked:=true;
  end;
 for I:=0 to DataSet.FieldCount-1 do
  begin //   
   Fld:=DataSet.Fields[I];
   IdFld:=FieldFechIndex[I+1];
    if (Fld.FieldKind = fkData) and (IdFld > -1) then
     begin
      //         -      
      IsData:=false;
      if not Fld.IsBlob then
       begin
        IsData:=not (VarType(FQuery.FRecordSet.Fields[IdFld].Value) = varNull);
        PAddData(AData+FetchDataSet.FieldOffset[Fld.FieldNo]+Fld.DataSize)^.IsData:=IsData;
       end;
      if Fld.IsBlob or IsData then
       AFechFuncList[Byte(Fld.DataType)](FQuery.FRecordSet, IdFld, AData + FetchDataSet.FieldOffset[Fld.FieldNo]);
     end;
  end;
 if not FQuery.Eof then
  FQuery.Next;
end;


procedure FetchError(RecordSet: _Recordset; FieldIndex: Word; Buffer: PChar);
begin
  raise TUnDbException.Create(str_ERROR_FETCH);
end;

procedure FetchString(RecordSet: _Recordset; FieldIndex: Word; Buffer: PChar);
var Val: string;
begin
 Val:=RecordSet.Fields[FieldIndex].Value;
 StrLCopy(Buffer, PChar(Val), Length(Val));
end;

procedure FetchSmallInt(RecordSet: _Recordset; FieldIndex: Word; Buffer: PChar);
begin
 PSmallInt(Buffer)^:=RecordSet.Fields[FieldIndex].Value;
end;

procedure FetchInteger(RecordSet: _Recordset; FieldIndex: Word; Buffer: PChar);
begin
 PInteger(Buffer)^:=RecordSet.Fields[FieldIndex].Value;
end;

procedure FetchWord(RecordSet: _Recordset; FieldIndex: Word; Buffer: PChar);
begin
 PWord(Buffer)^:=RecordSet.Fields[FieldIndex].Value;
end;

procedure FetchBoolean(RecordSet: _Recordset; FieldIndex: Word; Buffer: PChar);
begin
 PWordBool(Buffer)^:=RecordSet.Fields[FieldIndex].Value;
end;

procedure FetchFloat(RecordSet: _Recordset; FieldIndex: Word; Buffer: PChar);
begin
 PDouble(Buffer)^:=RecordSet.Fields[FieldIndex].Value;
end;

procedure FetchCurrency(RecordSet: _Recordset; FieldIndex: Word; Buffer: PChar);
begin
 PDouble(Buffer)^:=RecordSet.Fields[FieldIndex].Value;
end;

procedure FetchBCD(RecordSet: _Recordset; FieldIndex: Word; Buffer: PChar);
begin
 PDouble(Buffer)^:=RecordSet.Fields[FieldIndex].Value;
end;

procedure FetchDate(RecordSet: _Recordset; FieldIndex: Word; Buffer: PChar);
var TimeStampBuffer: TTimeStamp;
    DateTimeBuffer: TDateTime;
    Rec: TDateTimeRec;
begin
 DateTimeBuffer:=RecordSet.Fields[FieldIndex].Value;
 TimeStampBuffer:=DateTimeToTimeStamp(DateTimeBuffer);
 Rec.Date:=TimeStampBuffer.Date;
 move(Rec, Buffer^, sizeof(TDateTimeRec));
end;

procedure FetchTime(RecordSet: _Recordset; FieldIndex: Word; Buffer: PChar);
var TimeStampBuffer: TTimeStamp;
    DateTimeBuffer: TDateTime;
    Rec: TDateTimeRec;
begin
 DateTimeBuffer:=RecordSet.Fields[FieldIndex].Value;
 TimeStampBuffer:=DateTimeToTimeStamp(DateTimeBuffer);
 Rec.Time:=TimeStampBuffer.Time;
 move(Rec, Buffer^, sizeof(TDateTimeRec));
end;

procedure FetchDateTime(RecordSet: _Recordset; FieldIndex: Word; Buffer: PChar);
var TimeStampBuffer: TTimeStamp;
    DateTimeBuffer: TDateTime;
    Rec: TDateTimeRec;
begin
 DateTimeBuffer:=RecordSet.Fields[FieldIndex].Value;
 TimeStampBuffer:=DateTimeToTimeStamp(DateTimeBuffer);
 Rec.DateTime:=TimeStampToMSecs(TimeStampBuffer);
 move(Rec, Buffer^, sizeof(TDateTimeRec));
end;

procedure FetchBytes(RecordSet: _Recordset; FieldIndex: Word; Buffer: PChar);
var D: PChar;
    Count: Integer;
    V: OleVariant;
begin
 V:=RecordSet.Fields[FieldIndex].Value;
 Count:=VarArrayHighBound(V, 1)+1;
 D:=VarArrayLock(V);
 try
  move(D^, Buffer^, Count);
 finally
  VarArrayUnlock(V);
 end;
end;

procedure FetchVarBytes(RecordSet: _Recordset; FieldIndex: Word; Buffer: PChar);
var D: PChar;
    Count: Integer;
    V: OleVariant;
begin
 V:=RecordSet.Fields[FieldIndex].Value;
 Count:=VarArrayHighBound(V, 1)+1;
 D:=VarArrayLock(V);
 try
  move(D^, Buffer^, Count);
 finally
  VarArrayUnlock(V);
 end;
end;

procedure FetchBlob(RecordSet: _Recordset; FieldIndex: Word; Buffer: PChar);
begin
 PUnBlobQuad(Buffer)^.Blob:=-1;
end;

initialization

 for II:=0 to 22 do
  AFechFuncList[II]:=FetchError;

 AFechFuncList[Byte(ftString)]:=FetchString;
 AFechFuncList[Byte(ftSmallint)]:=FetchSmallInt;
 AFechFuncList[Byte(ftInteger)]:=FetchInteger;
 AFechFuncList[Byte(ftWord)]:=FetchWord;
 AFechFuncList[Byte(ftBoolean)]:=FetchBoolean;
 AFechFuncList[Byte(ftFloat)]:=FetchFloat;
 AFechFuncList[Byte(ftCurrency)]:=FetchCurrency;
 AFechFuncList[Byte(ftBCD)]:=FetchBCD;
 AFechFuncList[Byte(ftDate)]:=FetchDate;
 AFechFuncList[Byte(ftTime)]:=FetchTime;
 AFechFuncList[Byte(ftDateTime)]:=FetchDateTime;
 AFechFuncList[Byte(ftBytes)]:=FetchBytes;
 AFechFuncList[Byte(ftVarBytes)]:=FetchVarBytes;
 AFechFuncList[Byte(ftBlob)]:=FetchBlob;
 AFechFuncList[Byte(ftMemo)]:=FetchBlob;

end.

