
          //--------------------------------------------//
          //           .         //
          //            !           //
          //         Copiryght@ 1996-2004.              //
          //         Programmer Bannikov N.A.           //
          //         Universal Database Server 6.0      //
          //         STIKRIZ Technology.                //
          //--------------------------------------------//

unit UnConstants;

{$I Un.INC}                                              

interface

 uses Windows, SysUtils, Classes, Math, Controls, db, dbtables
{$IFDEF Un_UDB}
      ,SocketTransportInterfaces
{$ENDIF}
      ;

  Type

  PInteger      = ^Integer;
  PLong         = ^LongInt;
  PCardinal     = ^Cardinal;
  PWord         = ^Word;
  PSmallInt     = ^SmallInt;
  PByte         = ^Byte;
  PShortInt     = ^ShortInt;
  PSingle       = ^Single;
  PDouble       = ^Double;
  PDate         = ^Double;
  PWordBool     = ^WordBool;

  TTypeLexcem = (
                 untl_Char, untl_HEX, untl_String, untl_LP, untl_RP, untl_Mul,
                 untl_ExMul, untl_Plus, untl_Inc, untl_ExInc, untl_Comma, untl_Minus,
                 untl_Dec, untl_ExDec, untl_Point,  untl_PP, untl_Div, untl_ExDiv,
                 untl_TypeVar, untl_Givin, untl_EndLine, untl_Less, untl_SmalOrEqual,
                 untl_NotEqual, untl_Equal, untl_More, untl_MoreOrEqual, untl_Referance,
                 untl_And, untl_Array, untl_As, untl_Begin, untl_Break, untl_Case,
                 untl_CDECL, untl_Class, untl_Const, untl_Constructor,
                 untl_Continue, untl_Destructor, untl_Divs, untl_Do, untl_DownTo,
                 untl_Else, untl_End, untl_Except, untl_Exit, untl_Finalization,
                 untl_Finally, untl_For, untl_Forward, untl_Function, untl_If,
                 untl_Implementation, untl_In, untl_Inherited,
                 untl_Initialization, untl_Interface, untl_Is, untl_Label, untl_Mod,
                 untl_Not, untl_Object, untl_Of, untl_Operator, untl_Or,
                 untl_Overload, untl_Override, untl_Packed, untl_Pascal,
                 untl_Pointer, untl_Private, untl_Procedure, untl_Property,
                 untl_Protected, untl_Public, untl_Raise, untl_Read,
                 untl_Record, untl_Register, untl_Repeat, untl_Result,
                 untl_Safecall, untl_Self, untl_Set, untl_Shl, untl_Shr, untl_Stdcall,
                 untl_Then, untl_To, untl_Try, untl_Type, untl_Unit, untl_Until,
                 untl_Uses, untl_Var, untl_Virtual, untl_While, untl_With,
                 untl_Write, untl_Xor, untl_LIP, untl_RIP, untl_Addr
                );


  TEnumToken = (calck_None, calck_Const, calck_StrConst, calck_Var, calck_Proc,
                calck_ReservedWord, calck_Component, calck_Propertry, calck_Method,
                calck_End);

  TUnTypeObject = (unto_InternalProcedure, unto_InternalFunction,
                   unto_ExternalProcedure, unto_ExternalFunction,
                   unto_DefineProcedure, unto_DefineFunction,
                   unto_Variable, unto_Class);

  TUnTypeData = (undt_Unknown, undt_String,  undt_WideString, undt_Array,
                 undt_Word, undt_ShortInt, undt_Smallint, undt_Integer,
                 undt_Single, undt_Double, undt_Extended, undt_Cardinal,
                 undt_Comp, undt_Currency, undt_DateTime, undt_Boolean,
                 undt_Pointer, undt_Variant, undt_Byte, undt_Char,
                 undt_Object, undt_Const, undt_Var);

  TunDbDataType = (undbdt_Unknown, undbdt_Integer, undbdt_Float, undbdt_Money, undbdt_String,
                   undbdt_Boolean, undbdt_Date, undbdt_Time, undbdt_DateTime, undbdt_Blob,
                   undbdt_Reference, undbdt_Calculate);

  TUnBlockType = (unbt_Line, unbt_Block, unbt_For, unbt_While, unbt_Repeat,
                  unbt_TryFinally, unbt_TryExcept, unbt_If, unbt_Item, unbt_Case);

  TTypeAccountVariable = (untav_None, untav_Var, untav_Const);

  TUnTypeCommand = (untc_SQL, untc_OSQL, untc_Exec, untc_OExec, untc_GetBlob, untc_GetOBlob, untc_Command);

  TUnTypeEvents = (unte_Constructor, unte_Destructor, unte_OnDeleteError, unte_OnEditError,
                   unte_OnPostError, unte_BeforeOpen, unte_BeforeClose, unte_OnFilterRecord,
                   unte_AfterOpen, unte_AfterClose, unte_BeforeScroll, unte_AfterScroll,
                   unte_BeforeConstructor, unte_AfterConstructor, unte_BeforeEdit, unte_AfterEdit,
                   unte_AfterDestructor,  unte_BeforePost, unte_AfterPost, unte_BeforeCancel, unte_AfterCancel,
                   unte_OnCalckField);

  TUnFieldEvents = (unfe_OnChange, unfe_OnGetText, unfe_OnSetText, unfe_OnValidate, unfe_ClickButton, unfe_SetColor);

  EunCalckError = class(Exception);

  TCMMouseWheel = packed record
    Msg: Cardinal;
    ShiftState: TShiftState;
    Unused: Byte;
    WheelDelta: SmallInt;
    case Integer of
      0: (
        XPos: Smallint;
        YPos: Smallint);
      1: (
        Pos: TSmallPoint;
        Result: Longint);
  end;

  TWMMouseWheel = packed record
    Msg: Cardinal;
    Keys: SmallInt;
    WheelDelta: SmallInt;
    case Integer of
      0: (
        XPos: Smallint;
        YPos: Smallint);
      1: (
        Pos: TSmallPoint;
        Result: Longint);
  end;

  TUnCustomCommandObject = class(TComponent)
   private
    FCommand: TStringList;
    FParams: TParams;
    FMethod: Integer;
   protected
    FTypeCommand: TUnTypeCommand;
   public
    constructor Create(AOwner: TComponent);  override;
    destructor Destroy; override;
    procedure SaveParams(Str: TStream);
    procedure SaveToStream(Str: TStream);
    procedure LoadFromStream(Str: TStream);
    procedure LoadParams(Str: TStream);
    property TypeCommand: TUnTypeCommand  read FTypeCommand write FTypeCommand;
   published
    property Command: TStringList read FCommand;
    property Params: TParams  read FParams;
    property Method: Integer read FMethod write FMethod;
  end;

  var
   ReservedWords: array[0..103, 0..1] of string =
(
('#', '#'), ('$', '$'), ('''', ''''), ('(', '('), (')', ')'), ('*', '*'),
('*=', '*='), ('+', '+'), ('++', '++'), ('+=', '+='), (',', ','), ('-', '-'),
('--', '--'), ('-=', '-='), ('.', '.'), ('..', '..'), ('/', '/'), ('/=', '/='),
(':', ':'), (':=', ':='), (';', ';'), ('<', '<'), ('<=', '<='), ('<>', '<>'), ('=', '='),
('>', '>'), ('>=', '>='), ('@', '@'), ('AND', 'and'), ('ARRAY', 'array'), ('AS', 'as'),
('BEGIN', 'begin'), ('BREAK', 'Break'), ('CASE', 'Case'), ('CDECL', 'cdecl'),
('CLASS', 'class'), ('CONST', 'const'), ('CONSTRUCTOR', 'constructor'),
('CONTINUE', 'Continue'), ('DESTRUCTOR', 'destructor'), ('DIV', 'div'), ('DO', 'do'),
('DOWNTO', 'downto'), ('ELSE', 'else'), ('END', 'end'), ('EXCEPT', 'except'),
('EXIT', 'Exit'), ('FINALIZATION', 'finalization'), ('FINALLY', 'finally'),
('FOR', 'for'),  ('FORWARD', 'forward'),  ('FUNCTION', 'function'),
('IF', 'if'),  ('IMPLEMENTATION', 'implementation'),  ('IN', 'in'),
('INHERITED', 'inherited'), ('INITIALIZATION', 'initialization'),
('INTERFACE', 'interface'),  ('IS', 'is'), ('LABEL', 'Label'), ('MOD', 'mod'),  ('NOT', 'Not'),
('OBJECT', 'Object'),  ('OF', 'of'), ('OPERATOR', 'operator'), ('OR', 'or'),
('OVERLOAD', 'overload'), ('OVERRIDE', 'override'), ('PACKED', 'packed'),
('PASCAL', 'pascal'), ('POINTER', 'pointer'), ('PRIVATE', 'private'),
('PROCEDURE', 'procedure'), ('PROPERTY', 'property'), ('PROTECTED', 'protected'),
('PUBLIC', 'public'), ('RAISE', 'raise'), ('READ', 'read'), ('RECORD', 'record'),
('REGISTER', 'register'), ('REPEAT', 'repeat'), ('RESULT', 'Result'),
('SAFECALL', 'safecall'), ('SELF', 'Self'), ('SET', 'set'), ('SHL', 'shl'), ('SHR', 'shr'),
('STDCALL', 'stdcall'), ('THEN', 'then'), ('TO', 'to'), ('TRY', 'try'),
('TYPE', 'Type'), ('UNIT', 'unit'), ('UNTIL', 'until'), ('USES', 'uses'),
('VAR', 'var'), ('VIRTUAL', 'virtual'), ('WHILE', 'while'), ('WITH', 'With'),
('WRITE', 'write'), ('XOR', 'xor'), ('[', '['), (']', ']'), ('^', '^')
);

  TypeLexcemName: array[0..103] of string =
(
'untl_Char', 'untl_HEX', 'untl_String', 'untl_LP', 'untl_RP', 'untl_Mul',
'untl_ExMul', 'untl_Plus', 'untl_Inc', 'untl_ExInc', 'untl_Comma', 'untl_Minus',
'untl_Dec', 'untl_ExDec', 'untl_Point',  'untl_PP', 'untl_Div', 'untl_ExDiv',
'untl_TypeVar', 'untl_Givin', 'untl_EndLine', 'untl_Less', 'untl_SmalOrEqual',
'untl_NotEqual', 'untl_Equal', 'untl_More', 'untl_MoreOrEqual', 'untl_Referance', 'untl_And',
'untl_Array', 'untl_As', 'untl_Begin', 'untl_Break', 'untl_Case', 'untl_CDECL',
'untl_Class', 'untl_Const', 'untl_Constructor', 'untl_Continue',
'untl_Destructor', 'untl_Divs', 'untl_Do', 'untl_DownTo', 'untl_Else', 'untl_End',
'untl_Except', 'untl_Exit', 'untl_Finalization',  'untl_Finally', 'untl_For',
'untl_Forward', 'untl_Function', 'untl_If', 'untl_Implementation', 'untl_In',
'untl_Inherited', 'untl_Initialization', 'untl_Interface', 'untl_Is',
'untl_Label', 'untl_Mod', 'untl_Not', 'untl_Object', 'untl_Of', 'untl_Operator', 'untl_Or',
'untl_Overload', 'untl_Override', 'untl_Packed', 'untl_Pascal', 'untl_Pointer',
'untl_Private', 'untl_Procedure', 'untl_Property', 'untl_Protected',
'untl_Public', 'untl_Raise', 'untl_Read', 'untl_Record', 'untl_Register',
'untl_Repeat', 'untl_Result',  'untl_Safecall', 'untl_Self', 'untl_Set',
'untl_Shl', 'untl_Shr', 'untl_Stdcall',  'untl_Then', 'untl_To', 'untl_Try',
'untl_Type', 'untl_Unit', 'untl_Until', 'untl_Uses', 'untl_Var', 'untl_Virtual',
'untl_While', 'untl_With', 'untl_Write', 'untl_Xor', 'untl_LIP', 'untl_RIP',
'untl_Addr'
);
                                                   

TypeVariablesName: array[0..20, 0..1] of string =
(
('Unknown', 'UNKNOWN'), ('String', 'STRING'),  ('WideString', 'WIDESTRING'),
('Array', 'ARRAY'), ('Word', 'WORD'), ('ShortInt', 'SHORTINT'),
('Smallint', 'SMALLINT'), ('Integer', 'INTEGER'), ('Single', 'SINGLE'),
('Double', 'DOUBLE'), ('Extended', 'EXTENDED'), ('Cardinal', 'CARDINAL'),
('Comp', 'COMP'), ('Currency', 'CURRENCY'), ('TDateTime', 'TDATETIME'),
('Boolean', 'BOOLEAN'), ('Pointer', 'POINTER'), ('Variant', 'VARIANT'),
('Byte', 'BYTE'), ('Char', 'CHAR'), ('TObject', 'TOBJECT')
);

NamesMonth: array[1..12] of string =
(
'January',
'February',
'March',
'April',
'May',
'June',
'July',
'August',
'September',
'October',
'November',
'December'
);

  const


      CLR = #13#10;
      VAL_END = 'END';
      CONST_PREFIX = '$';
      VAR_PREFIX = '&';
      FUNC_PREFIX = '_';
      PROC_PREFIX = '@';
      CLASS_PREFIX = '!';

      //  

      UDB_GET_DATA = 0;
      UDB_SQL = 1;
      UDB_EXEC = 2;
      UDB_OSQL = 3;
      UDB_OEXEC = 4;
      UDB_COMMAND = 5;
      UDB_REGISTRY = 6;
      UDB_UNREGISTRY = 7;
      UDB_DELETE_HANDLE = 8;
      UDB_GET_BLOB = 9;
      UDB_GET_OBLOB = 10;

      //   UDB_COMMAND

      UDB_START_TRANSACTION =  1;
      UDB_COMMIT            =  2;
      UDB_ROLLBACK          =  3;

      UDB_GET_PROJECTS      =  4;  //     
      UDB_GET_DOCUMENTS     =  5;  //      
      UDB_GET_REG_TYPES     =  6;  //       
      UDB_GET_METADATA      =  7;  //       ,   
      UDB_GET_QUERYS        =  8;  //      
      UDB_GET_NEW_KEY       =  9;  //    ID_NUM   
      UDB_GET_DATASET       = 10;  //       
      UDB_GET_LEVEL         = 11;  //     
      UDB_DO_INSERT         = 12;  //    
      UDB_DO_UPDATE         = 13;  //  Update 
      UDB_DO_DELETE         = 14;  //   
      UDB_DO_REFRESH        = 15;  //  Refresh  
      UDB_DO_LOCK           = 16;  //   
      UDB_DO_GET_BLOB       = 17;  //    
      UDB_DO_SET_BLOB       = 18;  //    
      UDB_REGISTER          = 19;  //     
      UDB_UN_REGISTER       = 20;  //      
      UDB_GET_SECURITY      = 21;  //    security   
      UDB_GET_NEW_SECURITY  = 22;  //     Security
      UDB_GET_LANGUAGE_STR  = 23;  //       
      UDB_GET_FORM          = 24;  //       
      UDB_GET_CONTEXT       = 25;  //    
      UDB_DO_UNLOCK_RECORD  = 26;  //          
      UDB_GET_OWNER         = 27;  //     -     
      UDB_SET_OWNER         = 28;  //       
      UDB_GET_CLASS_ID      = 29;  //   ID    
      UDB_GET_LEVEL_ID      = 30;  //   ID    
      UDB_GET_FORM_ID       = 31;  //   ID     
      UDB_DUMMI             = 32;  //    !
      UDB_CLEAR_METADATA    = 33;  //     

      UDB_SET_GLOBAL_WORK       = 34;  //   ID_NUM     
      UDB_GET_GLOBAL_WORK       = 35;  //     ID_NUM     
      UDB_CLEAR_GLOBAL_WORK     = 36;  //    


      CM_MOUSEWHEEL             = CM_BASE + 67;
      WM_MOUSEWHEEL             = $020A;

      _ID_NUM = 'ID_NUM';
      _NULL = 'NULL';
      _ID_PROPERTY = 'ID_PROPERTY';
      _IdNum = 'IdNum';
      _IdClass = 'IdClass';
      __IdOwner = 'IdOwner';
      _This = 'This';
      _Action = 'Action';
      _Sender = 'Sender';
      _Text = 'Text';
      _ID_OWNER = 'ID_OWNER';

 const BreakSimbols = [' ', #13, #10, '[', ']', '(', ')', '/', '*', '+', '-', ':', '&', '@',
            '$', ',', '''', '|', '?', '!', '#', '^', '%', '=', '~', '`', '"', ';',
            '<', '>', '{', '}', #8, '\'];

  function FindeReservedWorld(const Lexcem: string; var TypeLexcem: TTypeLexcem): boolean;
  function GetFineReservedWorld(var Lexcem: string; var TypeLexcem: TTypeLexcem): boolean;
  function GetCountReservedWorlds: Byte;
  function GetReservedWorld(Index: Byte): string;
  function GetReservedWorldByType(TypeLexcem: TTypeLexcem): string;
  function GetNameTypeLexcem(TypeLexcem: TTypeLexcem): string;
  function ConvertHex(const Text: string): Integer;
  function CheckNumber(const Lexcem: string): boolean;
  procedure ClearList(List: TList);
  procedure ClearStringList(List: TStringList);
  function FindeTypeDataName(const AName: string; var TypeData: TUnTypeData): boolean;
  function GetNameTypeData(TypeData: TUnTypeData): string;

  //    

  procedure SaveInt(Value: Integer; Str: TStream);
  function LoadInt(Str: TStream): Integer;
  procedure SaveFloat(Value: Extended; Str: TStream);
  function LoadFloat(Str: TStream): Extended;
  procedure SaveDateTime(Value: TDateTime; Str: TStream);
  function LoadDateTime(Str: TStream): TDateTime;
  procedure SaveString(const Value: string; Str: TStream);
  function LoadString(Str: TStream): string;
  procedure SaveBool(Value: boolean; Str: TStream);
  function LoadBool(Str: TStream): boolean;
  procedure SaveByte(Value: Byte; Str: TStream);
  function LoadByte(Str: TStream): Byte;
  procedure SaveStream(Source: TStream; Dest: TStream);
  procedure LoadStream(Source: TStream; Dest: TStream);


  function _Min(V1, V2: Integer): Integer;
  function _Max(V1, V2: Integer): Integer;

  procedure SortStrings(Str: TStringList);
  function CoCreateGuid(var guid: TGUID): HResult; stdcall;

  function DecodeRadianToDegreeStr(Value: Extended; IsDolgota: boolean): string;
  function DecodeDegreeStrToRadian(const Value: string): Extended;

const
  ole32    = 'ole32.dll';

implementation

 uses UnMessages;

function CoCreateGuid;                  external ole32 name 'CoCreateGuid';

function DecodeRadianToDegreeStr(Value: Extended; IsDolgota: boolean): string;
var TempGrad: Extended;
    Plus: boolean;
begin
 Plus:=Value >= 0;
 {TempGrad:=Abs(RadToDeg(Value));
 Result:=FormatFloat('00', Trunc(TempGrad))+'$';
 TempGrad:=Frac(TempGrad)*60;
 Result:=Result+FormatFloat('00', Trunc(TempGrad))+'''';
 TempGrad:=Frac(TempGrad)*60;
 Result:=Result+FormatFloat('00', Round(TempGrad))+'"';  }

 TempGrad:=Abs(RadToDeg(Value));
 Result:=FormatFloat('00', Trunc(TempGrad))+'$';
 TempGrad:=Frac(TempGrad)*60;
 Result:=Result+FormatFloat('00', TRunc(TempGrad))+'''';
 TempGrad:=Frac(TempGrad)*60;
 Result:=Result+FormatFloat('00', Round(TempGrad))+'"';

 if Plus then
  begin
   if IsDolgota then
    Result:=Result+'E'
   else
    Result:=Result+'N';
  end
 else
  begin
   if IsDolgota then
    Result:=Result+'W'
   else
    Result:=Result+'S';
  end;
end;

function DecodeDegreeStrToRadian(const Value: string): Extended;
var Step: Integer;
    TempStr: string;
    Val: PChar;
    IsDecimalMinuta: boolean;
    GR, MN, SC: Integer;
    FloatMN: Extended;
    Knt: Integer;
begin
//                10$10'10"E   -   
//                10 10 10E    -   
//                10$10.55'E   -    
//                10 10.55E    -    
 Val:=PChar(Value);
 TempStr:='';
 Step:=1;
 IsDecimalMinuta:=false;
 Knt:=0;
 GR:=0;
 MN:=0;
 SC:=0;
 FloatMN:=0;
 while Val^ <> #0 do
  begin
   case Step of
    1: begin
        case Val^ of
         '0', '1', '2', '3', '4', '5', '6', '7', '8', '9':  TempStr:=TempStr+Val^;
         '$', ' ': begin
                    GR:=StrToInt(TempStr);
                    TempStr:='';
                    Step:=2;
                   end;
         else raise Exception.Create(str_Bad_Format_Data+#13#10+Value);
        end;
       end;
    2: begin
        case Val^ of
         '0', '1', '2', '3', '4', '5', '6', '7', '8', '9':  TempStr:=TempStr+Val^;
         '.', ',': begin
                    TempStr:=TempStr+DecimalSeparator;
                    IsDecimalMinuta:=true;
                   end;
         '''', ' ': begin
                     if IsDecimalMinuta then
                      FloatMN:=StrToFloat(TempStr)
                     else
                      MN:=StrToInt(TempStr);
                     TempStr:='';
                     if IsDecimalMinuta then
                      Step:=4
                     else
                      Step:=3;
                   end;
         'N', 'E', 'W', 'S', 'n', 'e', 'w', 's': begin
                     if IsDecimalMinuta then
                      FloatMN:=StrToFloat(TempStr)
                     else
                      MN:=StrToInt(TempStr);
                     TempStr:='';
                     if IsDecimalMinuta then
                      Step:=4
                     else
                      Step:=3;
                     Dec(Val);
                   end;
         else raise Exception.Create(str_Bad_Format_Data+#13#10+Value);
        end;
       end;
    3: begin
        case Val^ of
         '0', '1', '2', '3', '4', '5', '6', '7', '8', '9':  TempStr:=TempStr+Val^;
         '"', ' ': begin
                    SC:=StrToInt(TempStr);
                    TempStr:='';
                    Step:=4;
                   end;
         else raise Exception.Create(str_Bad_Format_Data+#13#10+Value);
        end;
       end;
    4: begin
        case Val^ of
         'N', 'E', 'n', 'e': Knt:=1;
         'W', 'S', 'w', 's': Knt:=-1;
        end;
        Step:=5;
       end;
    else Break;
   end;
   Inc(Val);
  end;
 if Step <> 5 then
  raise Exception.Create(str_Bad_Format_Data+#13#10+Value);
 if IsDecimalMinuta then
  Result:=Knt*DegToRad(GR+FloatMN/60)
 else
  Result:=Knt*DegToRad(GR+MN/60+SC/3600);
end;

function GetNameMethod(const AName: string): string;
var I, J: Integer;
    Len: Integer;
begin
 I:=1;
 Len:=Length(AName);
 while I <= Len do
  begin
   if AName[I] in BreakSimbols then
    begin
     J:=I+1;
     while J <= Len do
      begin
       if AName[J] in BreakSimbols then
        begin
         Result:=Trim(Copy(AName, I+1, J-I-1));
         Break;
        end;
       Inc(J)
      end;
     Break;
    end;
   Inc(I);
  end;
end;

procedure SortStrings(Str: TStringList);

procedure QuickSort(L, R: Integer);
var
  I, J: Integer;
  P: string;
begin
  repeat
    I := L;
    J := R;
    P := GetNameMethod(Str[(L + R) shr 1]);
    repeat
      while AnsiCompareText(GetNameMethod(Str[I]), P) < 0 do Inc(I);
      while AnsiCompareText(GetNameMethod(Str[J]), P) > 0 do Dec(J);
      if I <= J then
      begin
        Str.Exchange(I, J);
        Inc(I);
        Dec(J);
      end;
    until I > J;
    if L < J then QuickSort(L, J);
    L := I;
  until I >= R;
end;

begin
  if Str.Count > 1 then
   QuickSort(0, Str.Count - 1);
end;

function _Min(V1, V2: Integer): Integer;
begin
 if V1 < V2 then
  Result:=V1
 else
  Result:=V2;
end;

function _Max(V1, V2: Integer): Integer;
begin
 if V1 > V2 then
  Result:=V1
 else
  Result:=V2;
end;

function GetNameTypeData(TypeData: TUnTypeData): string;
begin
 Result:=TypeVariablesName[Byte(TypeData), 0];
end;

function FindeTypeDataName(const AName: string; var TypeData: TUnTypeData): boolean;
var I: Byte;
    TempName: string;
begin
 Result:=false;
 TempName:=UpperCase(AName);
 for I:=0 to 20 do
  begin
   if TypeVariablesName[I, 1] = TempName then
    begin
     Result:=true;
     TypeData:=TUnTypeData(I);
     break;
    end;
  end;
end;

//       
procedure ClearList(List: TList);
var I: Integer;
    Obj: TObject;
begin
 for I:=0 to List.Count-1 do
  begin
   Obj:=List[I];
   if Obj <> nil then
    Obj.Free;
  end;
 List.Clear;
end;

//        
procedure ClearStringList(List: TStringList);
var I: Integer;
    Obj: TObject;
begin
 for I:=0 to List.Count-1 do
  begin
   Obj:=List.Objects[I];
   if Obj <> nil then
    Obj.Free;
  end;
 List.Clear;
end;

// -  
function GetCountReservedWorlds: Byte;
begin
 Result:=103;
end;

//     
function GetReservedWorld(Index: Byte): string;
begin
 Result:=ReservedWords[Index, 1];
end;

//     
function GetReservedWorldByType(TypeLexcem: TTypeLexcem): string;
begin
 Result:=ReservedWords[Byte(TypeLexcem), 1];
end;

//    
function GetNameTypeLexcem(TypeLexcem: TTypeLexcem): string;
begin
 Result:=TypeLexcemName[Byte(TypeLexcem)];
end;

//    ,   -  
function FindeReservedWorld(const Lexcem: string; var TypeLexcem: TTypeLexcem): boolean;
var MaxIndex, MinIndex, TempIndex: Byte;
    TempLexcem: string;

function CheckFinde: boolean;
var Res: Integer;
begin
 Res:=CompareStr(ReservedWords[TempIndex, 0], TempLexcem);
 Result:=Res = 0;
 if Res <> 0 then
  begin
   if Res < 0 then
    MinIndex:=TempIndex
   else
    MaxIndex:=TempIndex;
   TempIndex:=MinIndex+Trunc((MaxIndex-MinIndex)/2);
  end;
end;

begin
 TempLexcem:=Trim(UpperCase(Lexcem));
 MaxIndex:=GetCountReservedWorlds;
 MinIndex:=0;
 TempIndex:=MinIndex+Trunc((MaxIndex-MinIndex)/2);
 Result:=false;
 while (MaxIndex - MinIndex) > 3 do
  begin
   if CheckFinde then
    begin
     TypeLexcem:=TTypeLexcem(TempIndex);
     Result:=true;
     break;
    end;
  end;
 if not Result then
   for TempIndex:=MinIndex to MaxIndex do
    begin
     if CompareStr(ReservedWords[TempIndex, 0], TempLexcem) = 0 then
      begin
       Result:=true;
       TypeLexcem:=TTypeLexcem(TempIndex);
       break;
      end
    end;
end;

//          
function GetFineReservedWorld(var Lexcem: string; var TypeLexcem: TTypeLexcem): boolean;
begin
 Result:=FindeReservedWorld(Lexcem, TypeLexcem);
 if Result then
  Lexcem:=ReservedWords[Byte(TypeLexcem), 1];
end;

//    ,       Exception  -     !
function CheckNumber(const Lexcem: string): boolean;
var I: Integer;
    OldSeparator: Char;
    IsPoint, IsMinus, IsE: boolean;
    s: PChar;
begin
 IsPoint:=false;
 IsMinus:=false;
 IsE:=false;
 OldSeparator:=DecimalSeparator;
 try
  DecimalSeparator := '.';
  s:=PChar(Lexcem);
  Result:=Trim(Lexcem) <> '';
  try
   //for I:=1 to Length(Lexcem) do
   if Result then
    begin
     I:=1;
     while s^ <> #0 do
      begin
      // if not ((Lexcem[I] >= '0') and (Lexcem[I] <= '9')) then
      //  if (Lexcem[I] <> '-') and (Lexcem[I] <> '.') and (UpperCase(Lexcem[I]) <> 'E') then
       if not ((s^ >= '0') and (s^ <= '9')) then
        if (s^ <> '-') and (s^ <> '.') and (UpperCase(s^) <> 'E') then
         begin
          Result:=false;
          Break;
         end
        else if I = 1 then
         begin
          Result:=false;
          Break;
         end
        else if s^ = '-' then
         begin
          if IsMinus then
           begin
            Result:=false;
            Break;
           end
          else
           IsMinus:=true;
         end
        else if s^ = '.' then
         begin
          if IsPoint then
           begin
            Result:=false;
            Break;
           end
          else
           IsPoint:=true;
         end
        else if UpperCase(s^) = 'E' then
         begin
          if IsE then
           begin
            Result:=false;
            Break;
           end
          else
           IsE:=true;
         end;
       Inc(s);
       Inc(I);
      end;
    if Result then
     FloatToStr(StrToFloat(Lexcem));
   end;
  except
   Result:=false;
  end;
 finally
  DecimalSeparator:=OldSeparator;
 end;
end;

//      
function ConvertHex(const Text: string): Integer;
var I, Q: Integer;
begin
 Result:=0;
 Q:=0;
 for I:=Length(Text) downto 1 do
  begin
   case UpperCase(Text[I])[1] of
    '0': Result:=Result;
    '1': Result:=Result+Trunc(Power(16, Q))*1;
    '2': Result:=Result+Trunc(Power(16, Q))*2;
    '3': Result:=Result+Trunc(Power(16, Q))*3;
    '4': Result:=Result+Trunc(Power(16, Q))*4;
    '5': Result:=Result+Trunc(Power(16, Q))*5;
    '6': Result:=Result+Trunc(Power(16, Q))*6;
    '7': Result:=Result+Trunc(Power(16, Q))*7;
    '8': Result:=Result+Trunc(Power(16, Q))*8;
    '9': Result:=Result+Trunc(Power(16, Q))*9;
    'A': Result:=Result+Trunc(Power(16, Q))*10;
    'B': Result:=Result+Trunc(Power(16, Q))*11;
    'C': Result:=Result+Trunc(Power(16, Q))*12;
    'D': Result:=Result+Trunc(Power(16, Q))*13;
    'E': Result:=Result+Trunc(Power(16, Q))*14;
    'F': Result:=Result+Trunc(Power(16, Q))*15;
    else raise EunCalckError.Create(ERROR_CONVERT_HEX);
   end;
   Inc(Q);
  end;
end;


procedure SaveInt(Value: Integer; Str: TStream);
begin
 Str.Write(Value, Sizeof(Integer));
end;

function LoadInt(Str: TStream): Integer;
begin
 Str.Read(Result, Sizeof(Integer));
end;

procedure SaveFloat(Value: Extended; Str: TStream);
begin
 Str.Write(Value, Sizeof(Extended));
end;

function LoadFloat(Str: TStream): Extended;
begin
 Str.Read(Result, Sizeof(Extended));
end;

procedure SaveDateTime(Value: TDateTime; Str: TStream);
begin
 Str.Write(Value, Sizeof(TDateTime));
end;

function LoadDateTime(Str: TStream): TDateTime;
begin
 Str.Read(Result, Sizeof(TDateTime));
end;

procedure SaveString(const Value: string; Str: TStream);
var Count: Integer;
begin
 Count:=Length(Value);
 Str.Write(Count, Sizeof(Integer));
 Str.Write(Value[1], Count);
end;

function LoadString(Str: TStream): string;
var Count: Integer;
begin
 Str.Read(Count, Sizeof(Integer));
 SetLength(Result, Count);
 Str.Read(Result[1], Count);
end;

procedure SaveBool(Value: boolean; Str: TStream);
begin
 Str.Write(Value, Sizeof(boolean));
end;

function LoadBool(Str: TStream): boolean;
begin
 Str.Read(Result, Sizeof(boolean));
end;

procedure SaveByte(Value: Byte; Str: TStream);
begin
 Str.Write(Value, Sizeof(Byte));
end;

function LoadByte(Str: TStream): Byte;
begin
 Str.Read(Result, Sizeof(Byte));
end;

procedure SaveStream(Source: TStream; Dest: TStream);
var SizeStr: Longint;
begin
 SizeStr:=Source.Size;
 Dest.Write(SizeStr, Sizeof(Longint));
 if SizeStr > 0 then
  begin
   Source.Position:=0;
   Dest.CopyFrom(Source, SizeStr);
  end;
end;

procedure LoadStream(Source: TStream; Dest: TStream);
var SizeStr: Longint;
begin
 Source.Read(SizeStr, Sizeof(Longint));
 Dest.Size:=0;
 if SizeStr > 0 then
  Dest.CopyFrom(Source, SizeStr);
end;

{-------------------------------TUnCommandObject-------------------------------}

constructor TUnCustomCommandObject.Create(AOwner: TComponent);
begin
 inherited;
 Name:='';
 FCommand:=TStringList.Create;
 FParams:=TParams.Create;
 FTypeCommand:=untc_SQL;
 FMethod:=0;
end;

destructor TUnCustomCommandObject.Destroy;
begin
 FCommand.Free;
 FParams.Free;
 inherited;
end;

procedure TUnCustomCommandObject.SaveToStream(Str: TStream);
begin
 SaveByte(Byte(TypeCommand), Str);
 SaveInt(FMethod, Str);
 SaveString(Command.Text, Str);
 SaveParams(Str);
end;

procedure TUnCustomCommandObject.LoadFromStream(Str: TStream);
begin
 TypeCommand:=TUnTypeCommand(LoadByte(Str));
 Method:=LoadInt(Str);
 Command.Text:=LoadString(Str);
 LoadParams(Str);
end;

procedure TUnCustomCommandObject.LoadParams(Str: TStream);
var I: Integer;
    Count: Integer;
    Par: TParam;
    ParamType: TParamType;
    Size: Integer;
    Buffer: PChar;
begin
 FParams.Clear;
 Count:=LoadInt(Str);
 for I:=0 to Count-1 do
  begin
   ParamType:=TParamType(LoadByte(Str));
   Par:=TParam.Create(Params, ParamType);
   Par.DataType:=TFieldType(LoadByte(Str));
   Par.Name:=LoadString(Str);
   case Par.DataType of
    ftString: Par.AsString:=LoadString(Str);
    ftSmallint, ftInteger, ftWord: Par.AsInteger:=LoadInt(Str);
    ftBoolean: Par.AsBoolean:=LoadBool(Str);
    ftFloat, ftCurrency, ftBCD: Par.AsFloat:=LoadFloat(Str);
    ftDate, ftTime, ftDateTime: Par.AsDateTime:=LoadDateTime(Str);
    ftBytes, ftVarBytes, ftBlob, ftMemo, ftGraphic, ftFmtMemo, ftParadoxOle, ftDBaseOle, ftTypedBinary: begin
      Str.Read(Size, Sizeof(Integer));
      GetMem(Buffer, Size);
      try
       Str.Read(Buffer^, Size);
       Par.SetBlobData(Buffer, Size);
      finally
       FreeMem(Buffer);
      end;
     end;
   end;
  end;
end;

procedure TUnCustomCommandObject.SaveParams(Str: TStream);
var I: Integer;
    Par: TParam;
    Size: Integer;
    Buffer: PChar;
begin
 SaveInt(FParams.Count, Str);
 for I:=0 to Params.Count-1 do
  begin
   Par:=Params[I];
   SaveByte(Byte(Par.ParamType), Str);
   SaveByte(Byte(Par.DataType), Str);
   SaveString(Par.Name, Str);
   case Par.DataType of
    ftString: SaveString(Par.AsString, Str);
    ftSmallint, ftInteger, ftWord: SaveInt(Par.AsInteger, Str);
    ftBoolean: SaveBool(Par.AsBoolean, Str);
    ftFloat, ftCurrency, ftBCD: SaveFloat(Par.AsFloat, Str);
    ftDate, ftTime, ftDateTime: SaveDateTime(Par.AsDateTime, Str);
    ftBytes, ftVarBytes, ftBlob, ftMemo, ftGraphic, ftFmtMemo, ftParadoxOle, ftDBaseOle, ftTypedBinary: begin
      if not Par.IsNull then
       begin
        try
         Size:=Par.GetDataSize;
        except
         Size:=0;
        end;
        if Size > 0 then
         begin
          GetMem(Buffer, Size);
          try
           Str.Write(Size, Sizeof(Integer));
           Par.GetData(Buffer);
           Str.Write(Buffer^, Size);
          finally
           FreeMem(Buffer);
          end;
         end
        else
         SaveInt(0, Str);
       end
      else
       SaveInt(0, Str);
     end;
   end;
  end;
end;

end.
