
          //--------------------------------------------//
          //           .         //
          //            !           //
          //         Copiryght@ 1996-2004.              //
          //         Programmer Bannikov N.A.           //
          //         Universal Database Server 6.0      //
          //         STIKRIZ Technology.                //
          //--------------------------------------------//

unit UnCustomAdoFetcher;

interface

 uses Windows, SysUtils, classes, Db, OleCtrls, ADOR_TLB, ADODB_TLB, UnConstants,
      UnCustomDataSet, UnFetchTable, UnRecordSet, ActiveX, ComObj, UnADOParams,
      Db, DbTables, AdoClasses;

 Type

   TAdoFechFunc = procedure(RecordSet: _Recordset; FieldIndex: Word; Buffer: PChar);

   TUnAdoAttribute = (una_CommitRetaining, una_AbortRetaining, una_AsyncPhaseOne, una_SyncPhaseOne);
   TUnAdoAttributes = set of TUnAdoAttribute;

   TUnAdoConnectMode  = (unam_ModeUnknown, unam_ModeRead, unam_ModeWrite,
       unam_ModeReadWrite, unam_ModeShareDenyRead, unam_ModeShareDenyWrite,
       unam_ModeShareExclusive, unam_ModeShareDenyNone);

   // 
   TUnCustomAdoFetcher = class(TUnCustomFetcher)
    private
     FQuery: TUnAdoRecordSet;          // 
     FieldFechIndex: POffsetsArray;    //   
     FCashSize: Integer;               //     
     procedure SetCashSize(Value: Integer);
     function GetLockType: TUnAdoLockType;
     procedure SetLockType(Value: TUnAdoLockType);
     procedure DoGetParamValue(const ParamName: string; IsOld: boolean; var ParamType: TFieldType; var ParamValue: Variant);
    protected
     function GetReadConnect: TUnAdoConnect; virtual;
     procedure SetReadConnect(Value: TUnAdoConnect); virtual;
     function GetWriteConnect: TUnAdoConnect; virtual; abstract;
     procedure SetWriteConnect(Value: TUnAdoConnect); virtual; abstract;
     function GetActive: boolean; override;
     procedure SetActive(const Value: boolean); override;
     function GetBof: boolean; override;
     function GetEof: boolean; override;
     function GetSQL: TStrings; override;
     procedure SetSQL(const Value: TStrings); override;
     procedure GetNextData(AData: PChar); override;
     procedure InitializeFields(ADataSet: TDataSet); override;
     function GetFieldCount: Word; override;
    public
     constructor Create(AOwner: TComponent); override;
     destructor Destroy; override;
     procedure Open; override;
     procedure Close; override;
    published
     property ReadConnect: TUnAdoConnect read GetReadConnect write SetReadConnect;
     property WriteConnect: TUnAdoConnect read GetWriteConnect write SetWriteConnect;
     property LockType: TUnAdoLockType read GetLockType write SetLockType;
     property CashSize: Integer read FCashSize write SetCashSize;
   end;

 var

  AFechFuncList: array[0..22] of TAdoFechFunc;
  II: Integer;

 const
  REGDB_E_CLASSNOTREG = HRESULT($80040154);
  str_ADOCreateError = 'Error creating object.  Please verify that the Microsoft Data Access Components 2.1 (or later) have been properly installed';

function CreateADOObject(const ClassID: TGUID): IUnknown;
function ADOTypeToFieldType(const ADOType: DataTypeEnum): TFieldType;
procedure ParsingSQL(const SQL: string; var RealSQL: string; Params: TUnADOParams; DoGetParam: TUnGetParametrValue);
procedure _DoGetParamValue(DataSet: TDataSet; const ParamName: string; IsOld: boolean; var ParamType: TFieldType; var ParamValue: Variant);
function _FindField(DataSet: TDataSet; const AFieldName: string; var Field: TField): boolean;
function _FindParam(Params: TParams; const AFieldName: string; var Param: TParam): boolean;


implementation

uses UnPasswordForm, Controls;

function _FindField(DataSet: TDataSet; const AFieldName: string; var Field: TField): boolean;
var I: Integer;
begin
 Result:=false;
 for I:=0 to DataSet.FieldCount-1 do
  begin
   if CompareText(DataSet.Fields[I].FieldName, AFieldName) = 0 then
    begin
     Field:=DataSet.Fields[I];
     Result:=true;
     Break;
    end;
  end;
end;

function _FindParam(Params: TParams; const AFieldName: string; var Param: TParam): boolean;
var I: Integer;
begin
 Result:=false;
 for I:=0 to Params.Count-1 do
  begin
   if CompareText(Params[I].Name, AFieldName) = 0 then
    begin
     Param:=Params[I];
     Result:=true;
     Break;
    end;
  end;
end;

procedure ParsingSQL(const SQL: string; var RealSQL: string; Params: TUnADOParams; DoGetParam: TUnGetParametrValue);
var I, J: Integer;
    TempString, StringValue: string;
    Len: Integer;
    DataType: TFieldType;
    ParamValue: Variant;
    IsOld: boolean;
    OldDecimalSeparator: Char;
    OldDateSeparator: Char;
    OldTimeSeparator: Char;
begin  //  
 OldDecimalSeparator:=DecimalSeparator;
 OldDateSeparator:=DateSeparator;
 OldTimeSeparator:=TimeSeparator;
 try
  DecimalSeparator:='.';
  DateSeparator:='.';
  TimeSeparator:=':';
  RealSQL:='';
  Len:=Length(SQL);
  I:=1;
  if Params <> nil then
  Params.Clear;
  while I <= Len do
   begin
    case SQL[I] of
      ':': begin //  
            TempString:='';
            Inc(I);
            IsOld:=false;
            while I <= Len do
             begin
              if ((SQL[I] < '0') or ((SQL[I] > '9') and (SQL[I] < 'A')) or (SQL[I] > 'z') or (I = Len)) and (SQL[I] <> '_') then
               begin //  
                if not Assigned(DoGetParam) then
                 raise Exception.Create(str_Not_Assigned_Param_Event);
                DoGetParam(TempString, IsOld, DataType, ParamValue);
                if ParamValue = Null then
                 begin
                  RealSQL:=RealSQL+' NULL';
                 end
                else
                 case DataType of
                  ftFmtMemo, ftMemo, ftString: begin
                    TempString:=ParamValue;
                    StringValue:='';
                    for J:=1 to Length(TempString) do
                     if TempString[J] = '''' then
                      StringValue:=StringValue+''''''
                     else
                      StringValue:=StringValue+TempString[J];
                    RealSQL:=RealSQL+''''+StringValue+''' ';
                   end;
                  ftBoolean: begin
                    if ParamValue then
                     RealSQL:=RealSQL+'1 '
                    else
                     RealSQL:=RealSQL+'0 ';
                   end;
                  ftSmallint, ftInteger, ftWord, ftAutoInc: RealSQL:=RealSQL+IntToStr(ParamValue)+' ';
                  ftFloat, ftCurrency, ftBCD:RealSQL:=RealSQL+FloatToStr(ParamValue)+' ';
                  ftDate: RealSQL:=RealSQL+DateToStr(ParamValue)+' ';
                  ftTime: RealSQL:=RealSQL+TimeToStr(ParamValue)+' ';
                  ftDateTime: RealSQL:=RealSQL+DateTimeToStr(ParamValue)+' ';
                  ftBytes, ftVarBytes, ftBlob, ftGraphic, ftParadoxOle, ftDBaseOle, ftTypedBinary: begin
                    RealSQL:=RealSQL+' ? ';
                    if Params <> nil then
                     Params.Add(TempString, DataType, pdInput, VarArrayHighBound(ParamValue, 1), ParamValue)
                    else  raise Exception.Create(str_Params_Not_Assigh);
                   end;
                  else raise Exception.Create(str_InvalidDataConversion);
                 end;
                Dec(I);
                Break;
               end
              else
               begin
                TempString:=TempString+SQL[I];
                if CompareText('Old_', TempString) = 0 then
                 begin
                  TempString:='';
                  IsOld:=true;
                 end;
               end;
              Inc(I);
             end;
           end;
      #13: RealSQL:=RealSQL+' '; //   
      #10: ;
      else RealSQL:=RealSQL+SQL[I]; //   
    end;
    Inc(I);
   end;
 finally
  DecimalSeparator:=OldDecimalSeparator;
  DateSeparator:=OldDateSeparator;
  TimeSeparator:=OldTimeSeparator;
 end;
end;

procedure _DoGetParamValue(DataSet: TDataSet; const ParamName: string; IsOld: boolean; var ParamType: TFieldType; var ParamValue: Variant);
var Fld: TField;
    Str: TStream;
    S: string;
    D: PChar;
    Param: TParam;
begin  //    
 if _FindField(DataSet, Trim(ParamName), Fld) then
  begin
   ParamType:=Fld.DataType;
   if Fld.IsBlob then
    begin
     Str:=GetTempStream;
     try
      (Fld as TBlobField).SaveToStream(Str);
      Str.Position:=0;
      case Fld.DataType of
       ftFmtMemo, ftMemo: begin
         SetLength(S, Str.Size);
         Str.ReadBuffer(S[1], Str.Size);
         ParamValue:=S;
        end;
       else begin
         ParamValue:=VarArrayCreate([0, Str.Size], varByte);
         D:=VarArrayLock(ParamValue);
         try
          Str.ReadBuffer(D^, Str.Size);
         finally
          VarArrayUnlock(ParamValue);
        end;
       end;
      end;
     finally
      Str.Free;
     end;
    end
   else
    begin
     if Fld.DataType = ftString then
      begin
       if IsOld then
        begin
         ParamValue:=Fld.OldValue;
         if ParamValue = Null then
          ParamValue:=Fld.Value;
        end
       else
        ParamValue:=Fld.Value;
      end
     else
      begin
       if IsOld then
        begin
         ParamValue:=Fld.OldValue;
         if ParamValue = Null then
          ParamValue:=Fld.Value;
        end
       else
        ParamValue:=Fld.Value;
      end;
    end;
  end
 else if DataSet is TUnFetchDataSet then
  begin
   if _FindParam(TUnFetchDataSet(DataSet).Params, Trim(ParamName), Param) then
    begin
     ParamType:=Param.DataType;
     if ParamType in [
                      ftBytes, ftVarBytes, ftBlob, ftMemo, ftGraphic,
                      ftFmtMemo, ftParadoxOle, ftDBaseOle, ftTypedBinary
{$IFDEF UN_D5}
                      , ftOraBlob
{$ENDIF}
                     ] then
      begin
       S:=Param.AsBlob;
       Str:=GetTempStream;
       try
        Str.Write(S[1], Length(S));
        Str.Position:=0;
        case Fld.DataType of
         ftFmtMemo, ftMemo: begin
           SetLength(S, Str.Size);
           Str.ReadBuffer(S[1], Str.Size);
           ParamValue:=S;
          end;
         else begin
           ParamValue:=VarArrayCreate([0, Str.Size], varByte);
           D:=VarArrayLock(ParamValue);
           try
            Str.ReadBuffer(D^, Str.Size);
           finally
            VarArrayUnlock(ParamValue);
          end;
         end;
        end;
       finally
        Str.Free;
       end;
      end
     else
      begin
       if Fld.DataType = ftString then
         ParamValue:=Param.AsString
       else
         ParamValue:=Param.Value;
      end;
    end
   else
    raise Exception.CreateFmt(str_Not_Find_Param, [ParamName]);
  end
 else
  raise Exception.CreateFmt(str_Not_Find_Param, [ParamName]);
end;

function ADOTypeToFieldType(const ADOType: DataTypeEnum): TFieldType;
begin  //   -  
  case ADOType of
    adEmpty: Result := ftUnknown;
    adTinyInt, adSmallInt: Result := ftSmallint;
    adError, adInteger, adUnsignedInt: Result := ftInteger;
    adUnsignedTinyInt, adUnsignedSmallInt: Result := ftWord;
    adSingle, adDouble: Result := ftFloat;
    adCurrency: Result := ftCurrency;
    adBoolean: Result := ftBoolean;
    adDBDate: Result := ftDate;
    adDBTime: Result := ftTime;
    adDate, adDBTimeStamp, adFileTime, adDBFileTime: Result := ftDateTime;
    adChar: Result := ftString;
    adVarChar: Result := ftString;
    adBSTR, adWChar, adVarWChar: Result := ftString;
    adLongVarChar, adLongVarWChar: Result := ftMemo;
    adLongVarBinary: Result := ftBlob;
    adBinary: Result := ftBytes;
    adVarBinary: Result := ftVarBytes;
{$IFDEF UN_D4}
    adBigInt, adUnsignedBigInt: Result:=ftLargeInt;
{$ENDIF}
{$IFDEF UN_D5}
    adPropVariant, adVariant: Result := ftVariant;
    adIDispatch: Result := ftIDispatch;
    adIUnknown: Result := ftInterface;
    adGUID: Result := ftGuid;
{$ELSEIF}
    adPropVariant, adVariant: Result := ftString;
{$ENDIF}
    adDecimal, adNumeric, adVarNumeric: Result := ftFloat
  else
    Result := ftUnknown;
  end;
end;

function CreateADOObject(const ClassID: TGUID): IUnknown;
var
  Status: LongInt;
  FPUControlWord: Word;
begin  //   
  asm
    FNSTCW  FPUControlWord
  end;
  Status := CoCreateInstance(ClassID, nil, CLSCTX_INPROC_SERVER or
    CLSCTX_LOCAL_SERVER, IUnknown, Result);
  asm
    FNCLEX
    FLDCW FPUControlWord
  end;
  if (Status = REGDB_E_CLASSNOTREG) then
    raise Exception.Create(str_ADOCreateError) else
    OleCheck(Status);
end;

{---------------------------------TUnAdoFecher---------------------------------}

constructor TUnCustomAdoFetcher.Create(AOwner: TComponent);
begin
 inherited;
 FQuery:=TUnAdoRecordSet.Create;
 FQuery.OnGetParam:=DoGetParamValue;
 FieldFechIndex:=nil;
end;

destructor TUnCustomAdoFetcher.Destroy;
begin
 FQuery.Free;
 inherited;
end;

function TUnCustomAdoFetcher.GetReadConnect: TUnAdoConnect;
begin
 Result:=FQuery.Connection;
end;

procedure TUnCustomAdoFetcher.SetReadConnect(Value: TUnAdoConnect);
begin
 FQuery.Connection:=Value;
end;

function TUnCustomAdoFetcher.GetLockType: TUnAdoLockType;
begin
 Result:=FQuery.LockType;
end;

procedure TUnCustomAdoFetcher.SetLockType(Value: TUnAdoLockType);
begin
 FQuery.LockType:=Value;
end;

function TUnCustomAdoFetcher.GetActive: boolean;
begin
 Result:=FQuery.Active;
end;

procedure TUnCustomAdoFetcher.SetActive(const Value: boolean);
begin
 if Value then
  Open
 else
  Close;
end;

procedure TUnCustomAdoFetcher.DoGetParamValue(const ParamName: string; IsOld: boolean; var ParamType: TFieldType; var ParamValue: Variant);
begin   //  
 if DataSet = nil then
  raise Exception.Create(str_Not_Assigned_DataSet);
 if FetchDataSet.MasterDataSource = nil then
  raise Exception.Create(str_Not_Assigned_Master_DataSource);
  _DoGetParamValue(FetchDataSet.MasterDataSource.DataSet, ParamName, IsOld, ParamType, ParamValue);
end;

function TUnCustomAdoFetcher.GetBof: boolean;
begin
 Result:=FQuery.Bof;
end;

function TUnCustomAdoFetcher.GetEof: boolean;
begin
 Result:=FQuery.Eof;
end;

function TUnCustomAdoFetcher.GetSQL: TStrings;
begin
 Result:=FQuery.SQL;
end;

procedure TUnCustomAdoFetcher.SetSQL(const Value: TStrings);
begin
 FQuery.SQL.Assign(Value);
end;

function TUnCustomAdoFetcher.GetFieldCount: Word;
begin
 Result:=FQuery.FieldCount;
end;

procedure TUnCustomAdoFetcher.Open;
begin
 if not Active then
  begin
   FIsFieldsChecked:=false;
   FQuery.CashSize:=FCashSize;
   FQuery.Open;
   if FieldFechIndex <> nil then //      
    FreeMem(FieldFechIndex);
   GetMem(FieldFechIndex, FQuery.FieldCount*Sizeof(Word));
   FillChar(FieldFechIndex^, FQuery.FieldCount*Sizeof(Word), 0); //  
  end;
end;

procedure TUnCustomAdoFetcher.SetCashSize(Value: Integer);
begin
 if Value > 0 then
  FCashSize:=Value
 else
  FCashSize:=1;
end;

procedure TUnCustomAdoFetcher.Close;
begin
 if Active then
  begin
   FQuery.Close;
   if FieldFechIndex <> nil then
    FreeMem(FieldFechIndex);
   FieldFechIndex:=nil;
  end;    
end;

procedure TUnCustomAdoFetcher.InitializeFields(ADataSet: TDataSet);
var I: Integer;
    FieldType: TFieldType;
    OldOpen: boolean;
    Def: TFieldDef;
begin   //    
 OldOpen:=FQuery.Active;
 try
  if not FQuery.Active then
   FQuery.Open;
  for I:=0 to FQuery.FieldCount-1 do
   begin //    
    FieldType:=ADOTypeToFieldType(FQuery.RecordSet.Fields[I].Type_);
    case FieldType of
     ftString: begin
       TFieldDef.Create(ADataSet.FieldDefs, FQuery.RecordSet.Fields[I].Name,
                  FieldType, FQuery.RecordSet.Fields[I].DefinedSize, false, I);
      end;
     ftSmallint: begin
       TFieldDef.Create(ADataSet.FieldDefs, FQuery.RecordSet.Fields[I].Name,
                  FieldType, 0, false, I);
      end;
     ftInteger: begin
       TFieldDef.Create(ADataSet.FieldDefs, FQuery.RecordSet.Fields[I].Name,
                  FieldType, 0, false, I);
      end;
     ftWord: begin
       TFieldDef.Create(ADataSet.FieldDefs, FQuery.RecordSet.Fields[I].Name,
                  FieldType, 0, false, I);
      end;
     ftBoolean: begin
       TFieldDef.Create(ADataSet.FieldDefs, FQuery.RecordSet.Fields[I].Name,
                  FieldType, 0, false, I);
      end;
     ftFloat: begin
       Def:=TFieldDef.Create(ADataSet.FieldDefs, FQuery.RecordSet.Fields[I].Name,
                  FieldType, 0, false, I);
       Def.Precision:=FQuery.RecordSet.Fields[I].Precision;
      end;
     ftCurrency: begin
       Def:=TFieldDef.Create(ADataSet.FieldDefs, FQuery.RecordSet.Fields[I].Name,
                  FieldType, 0, false, I);
       Def.Precision:=FQuery.RecordSet.Fields[I].Precision;
      end;
     ftDate: begin
       TFieldDef.Create(ADataSet.FieldDefs, FQuery.RecordSet.Fields[I].Name,
                  FieldType, 0, false, I);
      end;
     ftTime: begin
       TFieldDef.Create(ADataSet.FieldDefs, FQuery.RecordSet.Fields[I].Name,
                  FieldType, 0, false, I);
      end;
     ftDateTime: begin
       TFieldDef.Create(ADataSet.FieldDefs, FQuery.RecordSet.Fields[I].Name,
                  FieldType, 0, false, I);
      end;
     ftBytes: begin
       TFieldDef.Create(ADataSet.FieldDefs, FQuery.RecordSet.Fields[I].Name,
                  FieldType, FQuery.RecordSet.Fields[I].DefinedSize, false, I);
      end;
     ftVarBytes: begin
       TFieldDef.Create(ADataSet.FieldDefs, FQuery.RecordSet.Fields[I].Name,
                  FieldType, FQuery.RecordSet.Fields[I].DefinedSize, false, I);
      end;
     ftBlob: begin
       TFieldDef.Create(ADataSet.FieldDefs, FQuery.RecordSet.Fields[I].Name,
                  FieldType, 0, true, I);
      end;
     ftMemo: begin
       TFieldDef.Create(ADataSet.FieldDefs, FQuery.RecordSet.Fields[I].Name,
                  FieldType, 0, true, I);
      end;
     else raise TUnDbException.Create(str_InvalidDataConversion);
    end;
    FIsFieldsChecked:=false;
   end;
   FQuery.Close;
  finally
    FQuery.Active:=OldOpen;
  end;
end;

procedure TUnCustomAdoFetcher.GetNextData(AData: PChar);
var I, J: Integer;
    Fld: TField;
    IdFld: Word;
begin
 if not FIsFieldsChecked then
  begin //    
   for I:=0 to DataSet.FieldCount-1 do
    begin
     for J:=0 to FQuery.FieldCount-1 do
      begin
       if CompareText(DataSet.Fields[I].FieldName, FQuery.RecordSet.Fields[J].Name) = 0 then
        begin
         FieldFechIndex[I]:=J;
         if DataSet.Fields[I].DataType <> ADOTypeToFieldType(FQuery.RecordSet.Fields[J].Type_) then
           raise TUnDbException.Create(str_InvalidDataConversion);
         Break;
        end;
      end;
    end;
   FIsFieldsChecked:=true;
  end;
 for I:=0 to DataSet.FieldCount-1 do
  begin //   
   Fld:=DataSet.Fields[I];
   IdFld:=FieldFechIndex[I];
   if (Fld.FieldKind = fkData) and (IdFld > -1) then
    begin
     //         -      
     AFechFuncList[Byte(Fld.DataType)](FQuery.RecordSet, IdFld, AData + FetchDataSet.FieldOffset[Fld.Index]{, FechPosition});
    end;
  end;
 if not FQuery.Eof then
  FQuery.Next;
end;

procedure FetchError(RecordSet: _Recordset; FieldIndex: Word; Buffer: PChar{; FechPosition: Cardinal});
begin
  raise TUnDbException.Create(str_Error_Fetch);
end;

procedure FetchString(RecordSet: _Recordset; FieldIndex: Word; Buffer: PChar{; FechPosition: Cardinal});
var Val: string;
begin
 if VarType(RecordSet.Fields[FieldIndex].Value) = varNull then
  Val:=''
 else
  Val:=RecordSet.Fields[FieldIndex].Value;
 StrLCopy(Buffer, PChar(Val), Length(Val));
end;

procedure FetchSmallInt(RecordSet: _Recordset; FieldIndex: Word; Buffer: PChar{; FechPosition: Cardinal});
begin
 if VarType(RecordSet.Fields[FieldIndex].Value) = varNull then
  PSmallInt(Buffer)^:=0
 else
  PSmallInt(Buffer)^:=RecordSet.Fields[FieldIndex].Value;
end;

procedure FetchInteger(RecordSet: _Recordset; FieldIndex: Word; Buffer: PChar{; FechPosition: Cardinal});
begin
 if VarType(RecordSet.Fields[FieldIndex].Value) = varNull then
  PInteger(Buffer)^:=0
 else
   PInteger(Buffer)^:=RecordSet.Fields[FieldIndex].Value;
end;

procedure FetchWord(RecordSet: _Recordset; FieldIndex: Word; Buffer: PChar{; FechPosition: Cardinal});
begin
 if VarType(RecordSet.Fields[FieldIndex].Value) = varNull then
  PWord(Buffer)^:=0
 else
  PWord(Buffer)^:=RecordSet.Fields[FieldIndex].Value;
end;

procedure FetchBoolean(RecordSet: _Recordset; FieldIndex: Word; Buffer: PChar{; FechPosition: Cardinal});
begin
 if VarType(RecordSet.Fields[FieldIndex].Value) = varNull then
  PWordBool(Buffer)^:=false
 else
  PWordBool(Buffer)^:=RecordSet.Fields[FieldIndex].Value;
end;

procedure FetchFloat(RecordSet: _Recordset; FieldIndex: Word; Buffer: PChar{; FechPosition: Cardinal});
begin
 if VarType(RecordSet.Fields[FieldIndex].Value) = varNull then
  PDouble(Buffer)^:=0
 else
  PDouble(Buffer)^:=RecordSet.Fields[FieldIndex].Value;
end;

procedure FetchCurrency(RecordSet: _Recordset; FieldIndex: Word; Buffer: PChar{; FechPosition: Cardinal});
begin
 if VarType(RecordSet.Fields[FieldIndex].Value) = varNull then
  PDouble(Buffer)^:=0
 else
  PDouble(Buffer)^:=RecordSet.Fields[FieldIndex].Value;
end;

procedure FetchBCD(RecordSet: _Recordset; FieldIndex: Word; Buffer: PChar{; FechPosition: Cardinal});
begin
 if VarType(RecordSet.Fields[FieldIndex].Value) = varNull then
  PDouble(Buffer)^:=0
 else
  PDouble(Buffer)^:=RecordSet.Fields[FieldIndex].Value;
end;

procedure FetchDate(RecordSet: _Recordset; FieldIndex: Word; Buffer: PChar{; FechPosition: Cardinal});
var TimeStampBuffer: TTimeStamp;                                             
    DateTimeBuffer: TDateTime;
begin
 if VarType(RecordSet.Fields[FieldIndex].Value) = varNull then
  DateTimeBuffer:=0
 else
  DateTimeBuffer:=RecordSet.Fields[FieldIndex].Value;
 TimeStampBuffer:=DateTimeToTimeStamp(DateTimeBuffer);
 DateTimeBuffer := TimeStampToMSecs(TimeStampBuffer);
 move(DateTimeBuffer, Buffer^, sizeof(TDateTimeRec));
end;

procedure FetchTime(RecordSet: _Recordset; FieldIndex: Word; Buffer: PChar{; FechPosition: Cardinal});
var TimeStampBuffer: TTimeStamp;
    DateTimeBuffer: TDateTime;
begin
 if VarType(RecordSet.Fields[FieldIndex].Value) = varNull then
  DateTimeBuffer:=0
 else
  DateTimeBuffer:=RecordSet.Fields[FieldIndex].Value;
 TimeStampBuffer:=DateTimeToTimeStamp(DateTimeBuffer);
 DateTimeBuffer := TimeStampToMSecs(TimeStampBuffer);
 move(DateTimeBuffer, Buffer^, sizeof(TDateTimeRec));
end;

procedure FetchDateTime(RecordSet: _Recordset; FieldIndex: Word; Buffer: PChar{; FechPosition: Cardinal});
var TimeStampBuffer: TTimeStamp;
    DateTimeBuffer: TDateTime;
begin
 if VarType(RecordSet.Fields[FieldIndex].Value) = varNull then
  DateTimeBuffer:=0
 else
  DateTimeBuffer:=RecordSet.Fields[FieldIndex].Value;
 TimeStampBuffer:=DateTimeToTimeStamp(DateTimeBuffer);
 DateTimeBuffer := TimeStampToMSecs(TimeStampBuffer);
 move(DateTimeBuffer, Buffer^, sizeof(TDateTimeRec));
end;

procedure FetchBytes(RecordSet: _Recordset; FieldIndex: Word; Buffer: PChar{; FechPosition: Cardinal});
var D: PChar;
    Count: Integer;
    V: OleVariant;
begin
 if VarType(RecordSet.Fields[FieldIndex].Value) = varNull then
  FillChar(Buffer^, RecordSet.Fields[FieldIndex].DefinedSize, 0)
 else
  begin
   V:=RecordSet.Fields[FieldIndex].Value;
   Count:=VarArrayHighBound(V, 1)+1;
   D:=VarArrayLock(V);
   try
    move(D^, Buffer^, Count);
   finally
    VarArrayUnlock(V);
   end;
  end;
end;

procedure FetchVarBytes(RecordSet: _Recordset; FieldIndex: Word; Buffer: PChar{; FechPosition: Cardinal});
var D: PChar;
    Count: Integer;
    V: OleVariant;
begin
 if VarType(RecordSet.Fields[FieldIndex].Value) = varNull then
  FillChar(Buffer^, 1, 0)
 else
  begin
   V:=RecordSet.Fields[FieldIndex].Value;
   Count:=VarArrayHighBound(V, 1)+1;
   D:=VarArrayLock(V);
   try
    move(D^, Buffer^, Count);
   finally
    VarArrayUnlock(V);
   end;
  end;
end;

procedure FetchBlob(RecordSet: _Recordset; FieldIndex: Word; Buffer: PChar{; FechPosition: Cardinal});
begin
 PUnBlobQuad(Buffer)^.Blob:=-1;
end;

initialization

 for II:=0 to 22 do
  AFechFuncList[II]:=FetchError;

 AFechFuncList[Byte(ftString)]:=FetchString;
 AFechFuncList[Byte(ftSmallint)]:=FetchSmallInt;
 AFechFuncList[Byte(ftInteger)]:=FetchInteger;
 AFechFuncList[Byte(ftWord)]:=FetchWord;
 AFechFuncList[Byte(ftBoolean)]:=FetchBoolean;
 AFechFuncList[Byte(ftFloat)]:=FetchFloat;
 AFechFuncList[Byte(ftCurrency)]:=FetchCurrency;
 AFechFuncList[Byte(ftBCD)]:=FetchBCD;
 AFechFuncList[Byte(ftDate)]:=FetchDate;
 AFechFuncList[Byte(ftTime)]:=FetchTime;
 AFechFuncList[Byte(ftDateTime)]:=FetchDateTime;
 AFechFuncList[Byte(ftBytes)]:=FetchBytes;
 AFechFuncList[Byte(ftVarBytes)]:=FetchVarBytes;
 AFechFuncList[Byte(ftBlob)]:=FetchBlob;
 AFechFuncList[Byte(ftMemo)]:=FetchBlob;

end.

