
          //--------------------------------------------//
          //           .         //
          //            !           //
          //         Copiryght@ 1996-2004.              //
          //         Programmer Bannikov N.A.           //
          //         Universal Database Server 6.0      //
          //         STIKRIZ Technology.                //
          //--------------------------------------------//

unit UnSQLUpdater;

interface

 uses Classes, UnCustomDataSet, Db;

 Type

  TSQLBlobUpdater = class(TBlobUpdater)
   private
   protected
    function GetGetSQL: TStrings; virtual; abstract;
    procedure SetGetSQL(Value: TStrings); virtual; abstract;
    function GetSetSQL: TStrings; virtual; abstract;
    procedure SetSetSQL(Value: TStrings); virtual; abstract;
   public
   published
    property GetSQL: TStrings read GetGetSQL write SetGetSQL;
    property SetSQL: TStrings read GetSetSQL write SetSetSQL;
  end;

  TUnSQLBlobItem = class(TUnBlobItem)
   private
   protected
    function GetGetSQL: TStrings;
    procedure SetGetSQL(Value: TStrings);
    function GetSetSQL: TStrings;
    procedure SetSetSQL(Value: TStrings);
   public
   published
    property GetSQL: TStrings read GetGetSQL write SetGetSQL;
    property SetSQL: TStrings read GetSetSQL write SetSetSQL;
  end;

  TUnSQLUpdater = class(TUnCustomUpdater)
   private
    FInsertSQL: TStrings;
    FUpdateSQL: TStrings;
    FDeleteSQL: TStrings;
   protected
    function GetRefreshSQL: TStrings; virtual; abstract;
    procedure SetRefreshSQL(Value: TStrings); virtual; abstract;
    function GetInsertSQL: TStrings; virtual;
    procedure SetInsertSQL(Value: TStrings); virtual;
    function GetUpdateSQL: TStrings; virtual;
    procedure SetUpdateSQL(Value: TStrings); virtual;
    function GetDeleteSQL: TStrings; virtual;
    procedure SetDeleteSQL(Value: TStrings); virtual;
    function GetLockSQL: TStrings; virtual; abstract;
    procedure SetLockSQL(Value: TStrings); virtual; abstract;
   public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
   published
    property BlobsCollection;
    property RefreshSQL: TStrings read GetRefreshSQL write SetRefreshSQL;
    property InsertSQL: TStrings read GetInsertSQL write SetInsertSQL;
    property UpdateSQL: TStrings read GetUpdateSQL write SetUpdateSQL;
    property DeleteSQL: TStrings read GetDeleteSQL write SetDeleteSQL;
    property LockSQL: TStrings read GetLockSQL write SetLockSQL;
  end;

implementation

{-----------------------------TUnSQLBlobItem-----------------------------------}

function TUnSQLBlobItem.GetGetSQL: TStrings;
begin
 Result:=(FBlobUpdater as TSQLBlobUpdater).GetSQL;
end;

procedure TUnSQLBlobItem.SetGetSQL(Value: TStrings);
begin
 (FBlobUpdater as TSQLBlobUpdater).GetSQL.Assign(Value);
end;

function TUnSQLBlobItem.GetSetSQL: TStrings;
begin
 Result:=(FBlobUpdater as TSQLBlobUpdater).SetSQL;
end;

procedure TUnSQLBlobItem.SetSetSQL(Value: TStrings);
begin
 (FBlobUpdater as TSQLBlobUpdater).SetSQL.Assign(Value);
end;

{-------------------------------TUnSQLUpdater----------------------------------}

constructor TUnSQLUpdater.Create(AOwner: TComponent);
begin
 inherited;
 FInsertSQL:=TStringList.Create;
 FUpdateSQL:=TStringList.Create;
 FDeleteSQL:=TStringList.Create;
end;

destructor TUnSQLUpdater.Destroy;
begin
 FInsertSQL.Free;
 FUpdateSQL.Free;
 FDeleteSQL.Free;
 inherited;
end;

function TUnSQLUpdater.GetInsertSQL: TStrings;
begin
 Result:=FInsertSQL;
end;

procedure TUnSQLUpdater.SetInsertSQL(Value: TStrings);
begin
 FInsertSQL.Assign(Value);
end;

function TUnSQLUpdater.GetUpdateSQL: TStrings;
begin
 Result:=FUpdateSQL;
end;

procedure TUnSQLUpdater.SetUpdateSQL(Value: TStrings);
begin
 FUpdateSQL.Assign(Value);
end;

function TUnSQLUpdater.GetDeleteSQL: TStrings;
begin
 Result:=FDeleteSQL;
end;

procedure TUnSQLUpdater.SetDeleteSQL(Value: TStrings);
begin
 FDeleteSQL.Assign(Value);
end;

end.
